/*****************************************************************************
 * File:  SOZE_S_B_object.c
 *
 * Object:      |  (S_B)
 * Subsystem:   Ђ
 * Domain:      SOZE
 * Repository:  soze.ooa
 *
 * Notice:
 *   (C) Copyright 1999-2003 ROX Software, Inc.
 *   All rights reserved.
 *
 * Model Compiler:  MC3020 V3.3.0
 * Serial Number:   302033003113005
 *
 * Warnings:
 *   !!! THIS IS AN AUTO-GENERATED FILE. PLEASE DO NOT EDIT. !!!
 ****************************************************************************/

#include "SOZE_S_B_object.h"
#include "SOZE_S_B_events.h"
#include "SOZE_S_P_object.h"
#include "SOZE_S_S_object.h"
#include "SOZE_dom_debug.h"
#include "tm_layer.h"

    
/*****************************************************************************
 * Statically allocate space for the instance population for this object.
 * Allocate space for the object and its attributes.
 * Depending on the collection scheme, allocate containoids (collection
 * nodes) for gathering instances into free and active extents.
 ****************************************************************************/
static Escher_SetElement_s SOZE_S_B_container[ SOZE_S_B_MAX_EXTENT_SIZE ];
static SOZE_S_B_s SOZE_S_B_ObjectPool_s[ SOZE_S_B_MAX_EXTENT_SIZE ] ;
Escher_ObjectSet_s pG_SOZE_S_B_extent;
static Escher_ObjectSet_s p_SOZE_S_B_inanimate;

/*****************************************************************************
 * Initialize object factory services.
 ****************************************************************************/
void
SOZE_S_B_FactoryInit( void )
{
  /* Initialize object class extent (animate/active list) to empty.  */
  Escher_InitSet( &pG_SOZE_S_B_extent );

  /* Initialize object instance storage free pool (inanimate list)
   * by linking the empty instances into a collection.  */
  p_SOZE_S_B_inanimate.head = Escher_SetInsertBlock( &SOZE_S_B_container[ 0 ],
    (u1_t * const) &SOZE_S_B_ObjectPool_s[ 0 ],
    sizeof( SOZE_S_B_ObjectPool_s[ 0 ] ), SOZE_S_B_MAX_EXTENT_SIZE - 0 );
}

/*****************************************************************************
 * Class Creation Accessor
 ****************************************************************************/
SOZE_S_B_s *
SOZE_S_B_Create( void )
{
  Escher_SetElement_s * node;
  SOZE_S_B_s * self;

  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */

  /* Acquire instance storage from object free pool.  */
  node = p_SOZE_S_B_inanimate.head;
  p_SOZE_S_B_inanimate.head = p_SOZE_S_B_inanimate.head->next;
  self = (SOZE_S_B_s *) node->object;

  /* Initialize application analysis object attributes.  */
  self->m_position = 0;
  self->m_pondage_timeout = 0;
  self->m_discharge_timeout = 0;
  self->m_timer_id = 0;
  self->m_pomp_no = 0;

  /* Initialize relationship storage */
  self->mc_S_S_R1 = 0;
  self->mc_S_S_R2 = 0;
  self->mc_S_P_R3 = 0;

  self->m_current_state = SOZE_S_B_STATE_1;
  /* Insert instance into active extent (animate).  */
  Escher_SetInsertInstance( &pG_SOZE_S_B_extent, node );

  return self;
}


/*****************************************************************************
 * Class Deletion Accessor
 ****************************************************************************/
void
SOZE_S_B_Delete( SOZE_S_B_s * self )
{
  Escher_SetElement_s * slot;
  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */
  /* Remove instance from object extent.  */
  Escher_SetRemoveInstance( &pG_SOZE_S_B_extent, self, slot, SOZE_S_B_container, SOZE_S_B_ObjectPool_s );

  /* Release relationship storage */
  self->mc_S_S_R1 = 0;
  self->mc_S_S_R2 = 0;
  self->mc_S_P_R3 = 0;
  /* Reset identifying attribute(s) to system default values */
  self->m_position = 0;

  /* Set current state to an 'illegal' value */
  self->m_current_state = EVENT_CANT_HAPPEN;
  /* Release instance storage back to object free pool.  */
  slot->next = p_SOZE_S_B_inanimate.head;
  p_SOZE_S_B_inanimate.head = slot;
}

/*****************************************************************************
 * RELATE S_P TO S_B ACROSS R3
 ****************************************************************************/
void
SOZE_S_B_R3_Link( SOZE_S_P_s * part, SOZE_S_B_s * form )
{
  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */
  form->m_pomp_no = part->m_pomp_no;
#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_pomp_no_string_rep[10];
  sprintf( m_pomp_no_string_rep, "%d", form->m_pomp_no );
  
    ROX_TMProtocol_Notify_Modify_Referential_Attribute( 1, DomainID_SOZE, 1048577, ( unsigned long ) form, 1048598, m_pomp_no_string_rep, "form" );
  } /* end debug scope */
#endif

  form->mc_S_P_R3 = part;
  part->mc_S_B_R3 = form;
}

/*****************************************************************************
 * UNRELATE S_P FROM S_B ACROSS R3
 ****************************************************************************/
void
SOZE_S_B_R3_Unlink( SOZE_S_P_s * part, SOZE_S_B_s * form )
{
  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */
  form->m_pomp_no = 0;
#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_pomp_no_string_rep[10];
  sprintf( m_pomp_no_string_rep, "%d", form->m_pomp_no );
  
    ROX_TMProtocol_Notify_Modify_Referential_Attribute( 2, DomainID_SOZE, 1048577, ( unsigned long ) form, 1048598, m_pomp_no_string_rep, "form" );
  } /* end debug scope */
#endif


  form->mc_S_P_R3 = 0;
  part->mc_S_B_R3 = 0;
}



  /*
   * State-Event Matrix (SEM)
   * Row Index is object (MC enumerated) current state.
   * Row zero is the unitialized state (e.g., for creation event transitions).
   * Column Index is (MC enumerated) state machine events.
   */
  static const Escher_StateNumber_t SOZE_S_B_StateEventMatrix[6][5] =
  {
    /* Row 0: 'Unitialized' */
    { EVENT_CANT_HAPPEN, EVENT_CANT_HAPPEN, EVENT_CANT_HAPPEN, EVENT_CANT_HAPPEN, EVENT_CANT_HAPPEN },
    /* Row 1: SOZE_S_B_STATE_1 '' */
    { SOZE_S_B_STATE_2, EVENT_IS_IGNORED, EVENT_IS_IGNORED, EVENT_IS_IGNORED, EVENT_IS_IGNORED },
    /* Row 2: SOZE_S_B_STATE_2 '' */
    { EVENT_IS_IGNORED, SOZE_S_B_STATE_3, EVENT_IS_IGNORED, EVENT_IS_IGNORED, SOZE_S_B_STATE_5 },
    /* Row 3: SOZE_S_B_STATE_3 '' */
    { EVENT_IS_IGNORED, EVENT_IS_IGNORED, SOZE_S_B_STATE_4, EVENT_IS_IGNORED, EVENT_IS_IGNORED },
    /* Row 4: SOZE_S_B_STATE_4 '' */
    { EVENT_IS_IGNORED, EVENT_IS_IGNORED, EVENT_IS_IGNORED, SOZE_S_B_STATE_1, SOZE_S_B_STATE_5 },
    /* Row 5: SOZE_S_B_STATE_5 'ُ' */
    { SOZE_S_B_STATE_2, SOZE_S_B_STATE_3, EVENT_IS_IGNORED, SOZE_S_B_STATE_1, EVENT_IS_IGNORED }
  };

  /*
   * Array of pointers to the object state action methods.
   * Index is the (MC enumerated) number of the state action method to execute.
   */
  static const StateAction_t SOZE_S_B_Actions[6] =
  {
    (StateAction_t) 0,
    (StateAction_t) SOZE_S_B_Action_1,  /* '' */
    (StateAction_t) SOZE_S_B_Action_2,  /* '' */
    (StateAction_t) SOZE_S_B_Action_3,  /* '' */
    (StateAction_t) SOZE_S_B_Action_4,  /* '' */
    (StateAction_t) SOZE_S_B_Action_5   /* 'ُ' */
  };
#ifdef ROX_TM_ENABLED
  /***************************************************************************
   * array of state (SM_STATE) ids indexed by MC enumerated state number
   **************************************************************************/
  static const unsigned long SMstt_ID[6] =
  {
    0,
    1572866,  /* '' */
    1572865,  /* '' */
    1572867,  /* '' */
    1572868,  /* '' */
    1572869   /* 'ُ' */
  };

  /*****************************************************************************
 * array mapping state model event numbers to SMevt_ID (for debug)
 *****************************************************************************/
static const unsigned long
SMevt_ID[5] =
{
1572865,    /* S_B1:'n߂' */
1572866,    /* S_B2:'' */
1572867,    /* S_B3:'X' */
1572868,    /* S_B4:'鐅ȂȂ' */
1572869     /* S_B5:'ُ픭' */
};

#endif


/*****************************************************************************
 * SOZE_S_B_Dispatch - State model level event dispatching.
 ****************************************************************************/
void
SOZE_S_B_Dispatch( OoaEvent_t * event )
{
  SOZE_S_B_s * instance = (SOZE_S_B_s *)GetEventTargetInstance( event );
  Escher_EventNumber_t event_number = GetOoaEventNumber( event );
  Escher_StateNumber_t current_state;
  Escher_StateNumber_t next_state;
  
  if ( instance != 0 )
  {
    current_state = instance->m_current_state;
    if ( current_state > 5 )
    {
      /* Instance validation failure (object deleted while event in flight) */
      UserEventNoInstanceCallout( event_number );
    }
    else
    {
      next_state = SOZE_S_B_StateEventMatrix[ current_state ][ event_number ];
      if ( next_state <= 5 )
      {
        /* Execute the state action and update 'current state' */
#ifdef ROX_TM_ENABLED
        ROX_TMProtocol_Notify_State_Entry( DomainID_SOZE, 1572867, SMstt_ID[ next_state ], SMstt_ID[ current_state ], SMevt_ID[ GetOoaEventNumber(event) ], (unsigned long) event, (unsigned long) instance, (unsigned long) GetEventSendingInstance(event) );
#endif
        ( *SOZE_S_B_Actions[ next_state ] )( instance, event );
#ifdef ROX_TM_ENABLED
        ROX_TMProtocol_Notify_State_Exit( DomainID_SOZE, 1572867, SMstt_ID[ next_state ], (unsigned long) event );
#endif
        instance->m_current_state = next_state;
      }
      else
      {
        if ( next_state == EVENT_IS_IGNORED )
        {
#ifdef ROX_TM_ENABLED
          ROX_TMProtocol_Log_Event_Ignored( DomainID_SOZE, 1572867, SMstt_ID[ next_state ], (unsigned long) instance, SMevt_ID[ GetOoaEventNumber(event) ], (unsigned long) event );
#endif
          /* Event ignored - USER LOGIC IS TBD */
        }
      }
    }
  }
}


