/*****************************************************************************
 * File:  SOZE_S_D_object.c
 *
 * Object:      ^]  (S_D)
 * Subsystem:   Ђ
 * Domain:      SOZE
 * Repository:  soze.ooa
 *
 * Notice:
 *   (C) Copyright 1999-2003 ROX Software, Inc.
 *   All rights reserved.
 *
 * Model Compiler:  MC3020 V3.3.0
 * Serial Number:   302033003113005
 *
 * Warnings:
 *   !!! THIS IS AN AUTO-GENERATED FILE. PLEASE DO NOT EDIT. !!!
 ****************************************************************************/

#include "SOZE_S_D_object.h"
#include "SOZE_S_D_events.h"
#include "SOZE_S_P_object.h"
#include "SOZE_dom_debug.h"
#include "tm_layer.h"

    
/*****************************************************************************
 * Statically allocate space for the instance population for this object.
 * Allocate space for the object and its attributes.
 * Depending on the collection scheme, allocate containoids (collection
 * nodes) for gathering instances into free and active extents.
 ****************************************************************************/
static Escher_SetElement_s SOZE_S_D_container[ SOZE_S_D_MAX_EXTENT_SIZE ];
static SOZE_S_D_s SOZE_S_D_ObjectPool_s[ SOZE_S_D_MAX_EXTENT_SIZE ] ;
Escher_ObjectSet_s pG_SOZE_S_D_extent;
static Escher_ObjectSet_s p_SOZE_S_D_inanimate;

/*****************************************************************************
 * Initialize object factory services.
 ****************************************************************************/
void
SOZE_S_D_FactoryInit( void )
{
  /* Initialize object class extent (animate/active list) to empty.  */
  Escher_InitSet( &pG_SOZE_S_D_extent );

  /* Initialize object instance storage free pool (inanimate list)
   * by linking the empty instances into a collection.  */
  p_SOZE_S_D_inanimate.head = Escher_SetInsertBlock( &SOZE_S_D_container[ 0 ],
    (u1_t * const) &SOZE_S_D_ObjectPool_s[ 0 ],
    sizeof( SOZE_S_D_ObjectPool_s[ 0 ] ), SOZE_S_D_MAX_EXTENT_SIZE - 0 );
}

/*****************************************************************************
 * Class Creation Accessor
 ****************************************************************************/
SOZE_S_D_s *
SOZE_S_D_Create( void )
{
  Escher_SetElement_s * node;
  SOZE_S_D_s * self;

  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */

  /* Acquire instance storage from object free pool.  */
  node = p_SOZE_S_D_inanimate.head;
  p_SOZE_S_D_inanimate.head = p_SOZE_S_D_inanimate.head->next;
  self = (SOZE_S_D_s *) node->object;

  /* Initialize application analysis object attributes.  */
  self->m_wait_time = 0;
  self->m_running_timeout = 0;
  self->m_status = false;
  self->m_current_count = 0;
  self->m_interval_time = 0;
  self->m_running_timer_id = 0;

  /* Initialize relationship storage */
  self->mc_S_P_R4 = 0;

  self->m_current_state = SOZE_S_D_STATE_1;
  /* Insert instance into active extent (animate).  */
  Escher_SetInsertInstance( &pG_SOZE_S_D_extent, node );

  return self;
}


/*****************************************************************************
 * Class Deletion Accessor
 ****************************************************************************/
void
SOZE_S_D_Delete( SOZE_S_D_s * self )
{
  Escher_SetElement_s * slot;
  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */
  /* Remove instance from object extent.  */
  Escher_SetRemoveInstance( &pG_SOZE_S_D_extent, self, slot, SOZE_S_D_container, SOZE_S_D_ObjectPool_s );

  /* Release relationship storage */
  self->mc_S_P_R4 = 0;
  /* Reset identifying attribute(s) to system default values */
  self->m_wait_time = 0;

  /* Set current state to an 'illegal' value */
  self->m_current_state = EVENT_CANT_HAPPEN;
  /* Release instance storage back to object free pool.  */
  slot->next = p_SOZE_S_D_inanimate.head;
  p_SOZE_S_D_inanimate.head = slot;
}


  /*
   * State-Event Matrix (SEM)
   * Row Index is object (MC enumerated) current state.
   * Row zero is the unitialized state (e.g., for creation event transitions).
   * Column Index is (MC enumerated) state machine events.
   */
  static const Escher_StateNumber_t SOZE_S_D_StateEventMatrix[4][3] =
  {
    /* Row 0: 'Unitialized' */
    { EVENT_CANT_HAPPEN, EVENT_CANT_HAPPEN, EVENT_CANT_HAPPEN },
    /* Row 1: SOZE_S_D_STATE_1 '~' */
    { SOZE_S_D_STATE_2, EVENT_IS_IGNORED, EVENT_IS_IGNORED },
    /* Row 2: SOZE_S_D_STATE_2 '^]' */
    { EVENT_IS_IGNORED, SOZE_S_D_STATE_1, SOZE_S_D_STATE_3 },
    /* Row 3: SOZE_S_D_STATE_3 '^CAEgJEg' */
    { EVENT_IS_IGNORED, SOZE_S_D_STATE_1, SOZE_S_D_STATE_3 }
  };

  /*
   * Array of pointers to the object state action methods.
   * Index is the (MC enumerated) number of the state action method to execute.
   */
  static const StateAction_t SOZE_S_D_Actions[4] =
  {
    (StateAction_t) 0,
    (StateAction_t) SOZE_S_D_Action_1,  /* '~' */
    (StateAction_t) SOZE_S_D_Action_2,  /* '^]' */
    (StateAction_t) SOZE_S_D_Action_3   /* '^CAEgJEg' */
  };
#ifdef ROX_TM_ENABLED
  /***************************************************************************
   * array of state (SM_STATE) ids indexed by MC enumerated state number
   **************************************************************************/
  static const unsigned long SMstt_ID[4] =
  {
    0,
    2621441,  /* '~' */
    2621442,  /* '^]' */
    2621443   /* '^CAEgJEg' */
  };

  /*****************************************************************************
 * array mapping state model event numbers to SMevt_ID (for debug)
 *****************************************************************************/
static const unsigned long
SMevt_ID[3] =
{
2621441,    /* S_D1:'Jn' */
2621442,    /* S_D2:'~' */
2621443     /* S_D3:'JEgJn' */
};

#endif


/*****************************************************************************
 * SOZE_S_D_Dispatch - State model level event dispatching.
 ****************************************************************************/
void
SOZE_S_D_Dispatch( OoaEvent_t * event )
{
  SOZE_S_D_s * instance = (SOZE_S_D_s *)GetEventTargetInstance( event );
  Escher_EventNumber_t event_number = GetOoaEventNumber( event );
  Escher_StateNumber_t current_state;
  Escher_StateNumber_t next_state;
  
  if ( instance != 0 )
  {
    current_state = instance->m_current_state;
    if ( current_state > 3 )
    {
      /* Instance validation failure (object deleted while event in flight) */
      UserEventNoInstanceCallout( event_number );
    }
    else
    {
      next_state = SOZE_S_D_StateEventMatrix[ current_state ][ event_number ];
      if ( next_state <= 3 )
      {
        /* Execute the state action and update 'current state' */
#ifdef ROX_TM_ENABLED
        ROX_TMProtocol_Notify_State_Entry( DomainID_SOZE, 2621445, SMstt_ID[ next_state ], SMstt_ID[ current_state ], SMevt_ID[ GetOoaEventNumber(event) ], (unsigned long) event, (unsigned long) instance, (unsigned long) GetEventSendingInstance(event) );
#endif
        ( *SOZE_S_D_Actions[ next_state ] )( instance, event );
#ifdef ROX_TM_ENABLED
        ROX_TMProtocol_Notify_State_Exit( DomainID_SOZE, 2621445, SMstt_ID[ next_state ], (unsigned long) event );
#endif
        instance->m_current_state = next_state;
      }
      else
      {
        if ( next_state == EVENT_IS_IGNORED )
        {
#ifdef ROX_TM_ENABLED
          ROX_TMProtocol_Log_Event_Ignored( DomainID_SOZE, 2621445, SMstt_ID[ next_state ], (unsigned long) instance, SMevt_ID[ GetOoaEventNumber(event) ], (unsigned long) event );
#endif
          /* Event ignored - USER LOGIC IS TBD */
        }
      }
    }
  }
}


