/*****************************************************************************
 * File:  SOZE_S_S_object.c
 *
 * Object:      @  (S_S)
 * Subsystem:   Ђ
 * Domain:      SOZE
 * Repository:  soze.ooa
 *
 * Notice:
 *   (C) Copyright 1999-2003 ROX Software, Inc.
 *   All rights reserved.
 *
 * Model Compiler:  MC3020 V3.3.0
 * Serial Number:   302033003113005
 *
 * Warnings:
 *   !!! THIS IS AN AUTO-GENERATED FILE. PLEASE DO NOT EDIT. !!!
 ****************************************************************************/

#include "SOZE_S_S_object.h"
#include "SOZE_S_B_object.h"
#include "SOZE_dom_debug.h"
#include "tm_layer.h"

/*****************************************************************************
 * Statically allocate space for the instance population for this object.
 * Allocate space for the object and its attributes.
 * Depending on the collection scheme, allocate containoids (collection
 * nodes) for gathering instances into free and active extents.
 ****************************************************************************/
static Escher_SetElement_s SOZE_S_S_container[ SOZE_S_S_MAX_EXTENT_SIZE ];
static SOZE_S_S_s SOZE_S_S_ObjectPool_s[ SOZE_S_S_MAX_EXTENT_SIZE ] ;
Escher_ObjectSet_s pG_SOZE_S_S_extent;
static Escher_ObjectSet_s p_SOZE_S_S_inanimate;

/*****************************************************************************
 * Initialize object factory services.
 ****************************************************************************/
void
SOZE_S_S_FactoryInit( void )
{
  /* Initialize object class extent (animate/active list) to empty.  */
  Escher_InitSet( &pG_SOZE_S_S_extent );

  /* Initialize object instance storage free pool (inanimate list)
   * by linking the empty instances into a collection.  */
  p_SOZE_S_S_inanimate.head = Escher_SetInsertBlock( &SOZE_S_S_container[ 0 ],
    (u1_t * const) &SOZE_S_S_ObjectPool_s[ 0 ],
    sizeof( SOZE_S_S_ObjectPool_s[ 0 ] ), SOZE_S_S_MAX_EXTENT_SIZE - 0 );
}

/*****************************************************************************
 * Class Creation Accessor
 ****************************************************************************/
SOZE_S_S_s *
SOZE_S_S_Create( void )
{
  Escher_SetElement_s * node;
  SOZE_S_S_s * self;

  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */

  /* Acquire instance storage from object free pool.  */
  node = p_SOZE_S_S_inanimate.head;
  p_SOZE_S_S_inanimate.head = p_SOZE_S_S_inanimate.head->next;
  self = (SOZE_S_S_s *) node->object;

  /* Initialize application analysis object attributes.  */
  self->m_stone_no = 0;
  self->m_position = 0;
  self->m_corn_position = 0;

  /* Initialize relationship storage */
  self->mc_S_B_R1 = 0;
  self->mc_S_B_R2 = 0;

  /* Insert instance into active extent (animate).  */
  Escher_SetInsertInstance( &pG_SOZE_S_S_extent, node );

  return self;
}


/*****************************************************************************
 * Class Deletion Accessor
 ****************************************************************************/
void
SOZE_S_S_Delete( SOZE_S_S_s * self )
{
  Escher_SetElement_s * slot;
  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */
  /* Remove instance from object extent.  */
  Escher_SetRemoveInstance( &pG_SOZE_S_S_extent, self, slot, SOZE_S_S_container, SOZE_S_S_ObjectPool_s );

  /* Release relationship storage */
  self->mc_S_B_R1 = 0;
  self->mc_S_B_R2 = 0;
  /* Reset identifying attribute(s) to system default values */
  self->m_stone_no = 0;
  /* Release instance storage back to object free pool.  */
  slot->next = p_SOZE_S_S_inanimate.head;
  p_SOZE_S_S_inanimate.head = slot;
}

/*****************************************************************************
 * RELATE S_B TO S_S ACROSS R1
 ****************************************************************************/
void
SOZE_S_S_R1_Link( SOZE_S_B_s * part, SOZE_S_S_s * form )
{
  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */
  form->m_corn_position = part->m_position;
#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_corn_position_string_rep[10];
  sprintf( m_corn_position_string_rep, "%d", form->m_corn_position );
  
    ROX_TMProtocol_Notify_Modify_Referential_Attribute( 5, DomainID_SOZE, 1048579, ( unsigned long ) form, 1048591, m_corn_position_string_rep, "form" );
  } /* end debug scope */
#endif

  form->mc_S_B_R1 = part;
  part->mc_S_S_R1 = form;
}

/*****************************************************************************
 * UNRELATE S_B FROM S_S ACROSS R1
 ****************************************************************************/
void
SOZE_S_S_R1_Unlink( SOZE_S_B_s * part, SOZE_S_S_s * form )
{
  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */
  form->m_corn_position = 0;
#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_corn_position_string_rep[10];
  sprintf( m_corn_position_string_rep, "%d", form->m_corn_position );
  
    ROX_TMProtocol_Notify_Modify_Referential_Attribute( 6, DomainID_SOZE, 1048579, ( unsigned long ) form, 1048591, m_corn_position_string_rep, "form" );
  } /* end debug scope */
#endif


  form->mc_S_B_R1 = 0;
  part->mc_S_S_R1 = 0;
}


/*****************************************************************************
 * RELATE S_B TO S_S ACROSS R2
 ****************************************************************************/
void
SOZE_S_S_R2_Link( SOZE_S_B_s * part, SOZE_S_S_s * form )
{
  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */
  form->m_position = part->m_position;
#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_position_string_rep[10];
  sprintf( m_position_string_rep, "%d", form->m_position );
  
    ROX_TMProtocol_Notify_Modify_Referential_Attribute( 7, DomainID_SOZE, 1048579, ( unsigned long ) form, 1048590, m_position_string_rep, "form" );
  } /* end debug scope */
#endif

  form->mc_S_B_R2 = part;
  part->mc_S_S_R2 = form;
}

/*****************************************************************************
 * UNRELATE S_B FROM S_S ACROSS R2
 ****************************************************************************/
void
SOZE_S_S_R2_Unlink( SOZE_S_B_s * part, SOZE_S_S_s * form )
{
  /* Use TagEmptyHandleDetectionOn() to detect empty reference handles.  */
  form->m_position = 0;
#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_position_string_rep[10];
  sprintf( m_position_string_rep, "%d", form->m_position );
  
    ROX_TMProtocol_Notify_Modify_Referential_Attribute( 8, DomainID_SOZE, 1048579, ( unsigned long ) form, 1048590, m_position_string_rep, "form" );
  } /* end debug scope */
#endif


  form->mc_S_B_R2 = 0;
  part->mc_S_S_R2 = 0;
}




