/*****************************************************************************
 * File:  SOZE_sync_services.c
 *
 * Description:
 *   UML Domain Functions (Synchronous Services)
 *   for the following application analysis domain:
 *
 * Domain:     SOZE
 * Repository: soze.ooa
 *
 * Notice:
 *   (C) Copyright 1999-2003 ROX Software, Inc.
 *   All rights reserved.
 *
 * Model Compiler:  MC3020 V3.3.0
 * Serial Number:   302033003113005
 *
 * Warnings:
 *   !!! THIS IS AN AUTO-GENERATED FILE. PLEASE DO NOT EDIT. !!!
 ****************************************************************************/

#include "sys_mechs.h"
#include "sys_types.h"
#include "SOZE_S_B_object.h"
#include "SOZE_S_B_events.h"
#include "SOZE_S_P_object.h"
#include "SOZE_S_P_events.h"
#include "SOZE_S_S_object.h"
#include "SOZE_S_D_object.h"
#include "SOZE_S_D_events.h"
#include "SOZE_sync_services.h"
#include "SOZE_dom_debug.h"
#include "tm_layer.h"

#ifdef ROX_TM_ENABLED
#include "stdlib.h"   /* atoi, atol */
#include "tm_xmlparser.h"
#endif


#ifdef ROX_TM_ENABLED
static ul_t funcinv_id;
#endif


/*****************************************************************************
 * Domain Function:  Init
 ****************************************************************************/
/* Declare deferred routine for posting.  */
static void SOZE_Init_deferred( void );

void
SOZE_Init( void )
{
  ul_t ilbargs = (ul_t)  InterleaveBridge( SOZE_Init_deferred );
#ifdef ROX_TM_ENABLED
  funcinv_id = (ul_t) ilbargs;
  {unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;
  ROX_TMProtocol_Notify_Async_Function_Pending( DomainID_SOZE, 524289, funcinv_id, 0, func_parm_ids, func_parm_values );
  }
#endif
}

#ifdef ROX_TM_ENABLED
void
SOZE_Init_debug( void )
{
  ul_t ilbargs = (ul_t) InterleaveBridge( SOZE_Init_deferred );
#ifdef ROX_TM_ENABLED
  funcinv_id = (ul_t) ilbargs;
  {unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;
  ROX_TMProtocol_Notify_Async_Function_Pending( DomainID_SOZE, 524289, funcinv_id, 0, func_parm_ids, func_parm_values );
  }
#endif
}
#endif

static void
SOZE_Init_deferred( void )
{
#ifdef ROX_TM_ENABLED
  funcinv_id = (unsigned long) GetILBData();
  ROX_TMProtocol_Notify_Async_Function_Executing( DomainID_SOZE, 524289, funcinv_id );
#endif
  SOZE_Init_sync();
}

void
SOZE_Init_sync( void )
{
  SOZE_S_B_s * v1;  /* bamboo */
  SOZE_S_P_s * v6;  /* pomp */
  SOZE_S_S_s * v10;  /* stone */
  SOZE_S_D_s * v14;  /* ope */
  i_t v12;  /* stone_no */
#ifdef ROX_TM_ENABLED
  { /* debug scope */
  unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;  ROX_TMProtocol_Notify_Function_Entry( 24, DomainID_SOZE, 524289, funcinv_id, 0, func_parm_ids, func_parm_values );
  } /* end debug scope */
#endif

  /* CREATE OBJECT INSTANCE bamboo OF S_B */
  v1 = SOZE_S_B_Create();

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    unsigned long S_B_attr_ids[6] = {1048577, 1048594, 1048595, 1048599, 1048579, 1048598};
    const char* v1_attr_values[6];
    c_t m_position_string_rep[10];
    c_t m_pondage_timeout_string_rep[10];
    c_t m_discharge_timeout_string_rep[10];
    c_t m_timer_id_string_rep[10];
    c_t m_current_state_string_rep[10];
    c_t m_pomp_no_string_rep[10];
    sprintf( m_position_string_rep, "%d", v1->m_position );
  v1_attr_values[0] = m_position_string_rep;
    sprintf( m_pondage_timeout_string_rep, "%d", v1->m_pondage_timeout );
  v1_attr_values[1] = m_pondage_timeout_string_rep;
    sprintf( m_discharge_timeout_string_rep, "%d", v1->m_discharge_timeout );
  v1_attr_values[2] = m_discharge_timeout_string_rep;
    sprintf( m_timer_id_string_rep, "%lu", (unsigned long) v1->m_timer_id );
  v1_attr_values[3] = m_timer_id_string_rep;
    sprintf( m_current_state_string_rep, "%lu", (unsigned long) v1->m_current_state );
  v1_attr_values[4] = m_current_state_string_rep;
    sprintf( m_pomp_no_string_rep, "%d", v1->m_pomp_no );
  v1_attr_values[5] = m_pomp_no_string_rep;

    ROX_TMProtocol_Notify_Create_Object_Instance( 2, DomainID_SOZE, 1048577, ( unsigned long ) v1, TRUE, "bamboo", 6, S_B_attr_ids, v1_attr_values );
  } /* end debug scope */
#endif

  /* ASSIGN bamboo.position = 1 */
  v1->m_position = 1;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_position_string_rep[10];
    sprintf( m_position_string_rep, "%d", v1->m_position );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 3, DomainID_SOZE, 1048577, ( unsigned long ) v1, 1048577, "bamboo", m_position_string_rep, "1" );
  } /* end debug scope */
#endif

  /* ASSIGN bamboo.pondage_timeout = 80000000 */
  v1->m_pondage_timeout = 80000000;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_pondage_timeout_string_rep[10];
    sprintf( m_pondage_timeout_string_rep, "%d", v1->m_pondage_timeout );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 4, DomainID_SOZE, 1048577, ( unsigned long ) v1, 1048594, "bamboo", m_pondage_timeout_string_rep, "80000000" );
  } /* end debug scope */
#endif

  /* ASSIGN bamboo.discharge_timeout = 20000000 */
  v1->m_discharge_timeout = 20000000;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_discharge_timeout_string_rep[10];
    sprintf( m_discharge_timeout_string_rep, "%d", v1->m_discharge_timeout );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 5, DomainID_SOZE, 1048577, ( unsigned long ) v1, 1048595, "bamboo", m_discharge_timeout_string_rep, "20000000" );
  } /* end debug scope */
#endif

  /* CREATE OBJECT INSTANCE pomp OF S_P */
  v6 = SOZE_S_P_Create();

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    unsigned long S_P_attr_ids[4] = {1048582, 1048593, 1048583, 1048597};
    const char* v6_attr_values[4];
    c_t m_pomp_no_string_rep[10];
    c_t m_restart_string_rep[2];
    c_t m_current_state_string_rep[10];
    c_t m_wait_time_string_rep[10];
    sprintf( m_pomp_no_string_rep, "%d", v6->m_pomp_no );
  v6_attr_values[0] = m_pomp_no_string_rep;
    sprintf( m_restart_string_rep, "%u", v6->m_restart );
  v6_attr_values[1] = m_restart_string_rep;
    sprintf( m_current_state_string_rep, "%lu", (unsigned long) v6->m_current_state );
  v6_attr_values[2] = m_current_state_string_rep;
    sprintf( m_wait_time_string_rep, "%d", v6->m_wait_time );
  v6_attr_values[3] = m_wait_time_string_rep;

    ROX_TMProtocol_Notify_Create_Object_Instance( 7, DomainID_SOZE, 1048578, ( unsigned long ) v6, TRUE, "pomp", 4, S_P_attr_ids, v6_attr_values );
  } /* end debug scope */
#endif

  /* ASSIGN pomp.pomp_no = 1 */
  v6->m_pomp_no = 1;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_pomp_no_string_rep[10];
    sprintf( m_pomp_no_string_rep, "%d", v6->m_pomp_no );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 8, DomainID_SOZE, 1048578, ( unsigned long ) v6, 1048582, "pomp", m_pomp_no_string_rep, "1" );
  } /* end debug scope */
#endif

  /* ASSIGN pomp.restart = FALSE */
  v6->m_restart = false;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_restart_string_rep[2];
    sprintf( m_restart_string_rep, "%u", v6->m_restart );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 9, DomainID_SOZE, 1048578, ( unsigned long ) v6, 1048593, "pomp", m_restart_string_rep, "FALSE" );
  } /* end debug scope */
#endif

  /* CREATE OBJECT INSTANCE stone OF S_S */
  v10 = SOZE_S_S_Create();

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    unsigned long S_S_attr_ids[3] = {1048580, 1048590, 1048591};
    const char* v10_attr_values[3];
    c_t m_stone_no_string_rep[10];
    c_t m_position_string_rep[10];
    c_t m_corn_position_string_rep[10];
    sprintf( m_stone_no_string_rep, "%d", v10->m_stone_no );
  v10_attr_values[0] = m_stone_no_string_rep;
    sprintf( m_position_string_rep, "%d", v10->m_position );
  v10_attr_values[1] = m_position_string_rep;
    sprintf( m_corn_position_string_rep, "%d", v10->m_corn_position );
  v10_attr_values[2] = m_corn_position_string_rep;

    ROX_TMProtocol_Notify_Create_Object_Instance( 11, DomainID_SOZE, 1048579, ( unsigned long ) v10, TRUE, "stone", 3, S_S_attr_ids, v10_attr_values );
  } /* end debug scope */
#endif

  /* ASSIGN stone_no = 1 */
  v12 = 1;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t v12_string_rep[10];
    sprintf( v12_string_rep, "%d", v12 );
  
    ROX_TMProtocol_Notify_Modify_Local_Variable( 13, TRUE, "stone_no", v12_string_rep, "1" );
  } /* end debug scope */
#endif

  /* CREATE OBJECT INSTANCE ope OF S_D */
  v14 = SOZE_S_D_Create();

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    unsigned long S_D_attr_ids[7] = {1048581, 1048596, 1048601, 1048602, 1048604, 1048603, 1048600};
    const char* v14_attr_values[7];
    c_t m_wait_time_string_rep[10];
    c_t m_running_timeout_string_rep[10];
    c_t m_status_string_rep[2];
    c_t m_current_count_string_rep[10];
    c_t m_interval_time_string_rep[10];
    c_t m_running_timer_id_string_rep[10];
    c_t m_current_state_string_rep[10];
    sprintf( m_wait_time_string_rep, "%d", v14->m_wait_time );
  v14_attr_values[0] = m_wait_time_string_rep;
    sprintf( m_running_timeout_string_rep, "%d", v14->m_running_timeout );
  v14_attr_values[1] = m_running_timeout_string_rep;
    sprintf( m_status_string_rep, "%u", v14->m_status );
  v14_attr_values[2] = m_status_string_rep;
    sprintf( m_current_count_string_rep, "%d", v14->m_current_count );
  v14_attr_values[3] = m_current_count_string_rep;
    sprintf( m_interval_time_string_rep, "%d", v14->m_interval_time );
  v14_attr_values[4] = m_interval_time_string_rep;
    sprintf( m_running_timer_id_string_rep, "%lu", (unsigned long) v14->m_running_timer_id );
  v14_attr_values[5] = m_running_timer_id_string_rep;
    sprintf( m_current_state_string_rep, "%lu", (unsigned long) v14->m_current_state );
  v14_attr_values[6] = m_current_state_string_rep;

    ROX_TMProtocol_Notify_Create_Object_Instance( 15, DomainID_SOZE, 1048580, ( unsigned long ) v14, TRUE, "ope", 7, S_D_attr_ids, v14_attr_values );
  } /* end debug scope */
#endif

  /* ASSIGN ope.wait_time = 1000000 */
  v14->m_wait_time = 1000000;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_wait_time_string_rep[10];
    sprintf( m_wait_time_string_rep, "%d", v14->m_wait_time );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 16, DomainID_SOZE, 1048580, ( unsigned long ) v14, 1048581, "ope", m_wait_time_string_rep, "1000000" );
  } /* end debug scope */
#endif

  /* ASSIGN ope.running_timeout = 180 */
  v14->m_running_timeout = 180;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_running_timeout_string_rep[10];
    sprintf( m_running_timeout_string_rep, "%d", v14->m_running_timeout );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 17, DomainID_SOZE, 1048580, ( unsigned long ) v14, 1048596, "ope", m_running_timeout_string_rep, "180" );
  } /* end debug scope */
#endif

  /* ASSIGN ope.interval_time = 60000000 */
  v14->m_interval_time = 60000000;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_interval_time_string_rep[10];
    sprintf( m_interval_time_string_rep, "%d", v14->m_interval_time );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 18, DomainID_SOZE, 1048580, ( unsigned long ) v14, 1048604, "ope", m_interval_time_string_rep, "60000000" );
  } /* end debug scope */
#endif

  /* ASSIGN ope.current_count = 0 */
  v14->m_current_count = 0;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_current_count_string_rep[10];
    sprintf( m_current_count_string_rep, "%d", v14->m_current_count );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 19, DomainID_SOZE, 1048580, ( unsigned long ) v14, 1048602, "ope", m_current_count_string_rep, "0" );
  } /* end debug scope */
#endif

  /* ASSIGN ope.status = FALSE */
  v14->m_status = false;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_status_string_rep[2];
    sprintf( m_status_string_rep, "%u", v14->m_status );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 20, DomainID_SOZE, 1048580, ( unsigned long ) v14, 1048601, "ope", m_status_string_rep, "FALSE" );
  } /* end debug scope */
#endif

  /* RELATE bamboo TO pomp ACROSS R3 */
  SOZE_S_B_R3_Link( v6, v1 );

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Notify_Relationship_Creation( 21, DomainID_SOZE, 1048579, ( unsigned long )v1, "bamboo", ( unsigned long )v6, "pomp", "" );
#endif

  /* RELATE bamboo TO stone ACROSS R1 */
  SOZE_S_S_R1_Link( v1, v10 );

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Notify_Relationship_Creation( 22, DomainID_SOZE, 1048577, ( unsigned long )v1, "bamboo", ( unsigned long )v10, "stone", "" );
#endif

  /* RELATE pomp TO ope ACROSS R4 */
  SOZE_S_P_R4_Link( v14, v6 );

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Notify_Relationship_Creation( 23, DomainID_SOZE, 1048580, ( unsigned long )v6, "pomp", ( unsigned long )v14, "ope", "" );
#endif
#ifdef ROX_TM_ENABLED
  { /* debug scope */
  ROX_TMProtocol_Notify_Function_Exit( 25, DomainID_SOZE, 524289, ( funcinv_id == 0 ) ? 1 : 0 );
  funcinv_id = 0;
  } /* end debug scope */
#endif

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Notify_Function_Exit( 26, 35828, 524289, 1 );
#endif
}


/*****************************************************************************
 * Domain Function:  Start
 ****************************************************************************/
/* Declare deferred routine for posting.  */
static void SOZE_Start_deferred( void );

void
SOZE_Start( void )
{
  ul_t ilbargs = (ul_t)  InterleaveBridge( SOZE_Start_deferred );
#ifdef ROX_TM_ENABLED
  funcinv_id = (ul_t) ilbargs;
  {unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;
  ROX_TMProtocol_Notify_Async_Function_Pending( DomainID_SOZE, 524290, funcinv_id, 0, func_parm_ids, func_parm_values );
  }
#endif
}

#ifdef ROX_TM_ENABLED
void
SOZE_Start_debug( void )
{
  ul_t ilbargs = (ul_t) InterleaveBridge( SOZE_Start_deferred );
#ifdef ROX_TM_ENABLED
  funcinv_id = (ul_t) ilbargs;
  {unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;
  ROX_TMProtocol_Notify_Async_Function_Pending( DomainID_SOZE, 524290, funcinv_id, 0, func_parm_ids, func_parm_values );
  }
#endif
}
#endif

static void
SOZE_Start_deferred( void )
{
#ifdef ROX_TM_ENABLED
  funcinv_id = (unsigned long) GetILBData();
  ROX_TMProtocol_Notify_Async_Function_Executing( DomainID_SOZE, 524290, funcinv_id );
#endif
  SOZE_Start_sync();
}

void
SOZE_Start_sync( void )
{
  SOZE_S_D_s * v27;  /* ope */
#ifdef ROX_TM_ENABLED
  { /* debug scope */
  unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;  ROX_TMProtocol_Notify_Function_Entry( 32, DomainID_SOZE, 524290, funcinv_id, 0, func_parm_ids, func_parm_values );
  } /* end debug scope */
#endif

  /* SELECT ANY ope FROM INSTANCES OF S_D */
  v27 = (SOZE_S_D_s *) Escher_SetGetAny( &pG_SOZE_S_D_extent );

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Log_Select_from_execution( 28, "ANY", "S_D", TRUE, "ope" );
#endif

  /* ASSIGN ope.status = TRUE */
  v27->m_status = true;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_status_string_rep[2];
    sprintf( m_status_string_rep, "%u", v27->m_status );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 29, DomainID_SOZE, 1048580, ( unsigned long ) v27, 1048601, "ope", m_status_string_rep, "TRUE" );
  } /* end debug scope */
#endif

  /* GENERATE S_D1:'Jn'() TO ope */
  {
    OoaEvent_t * event30 = Escher_NewOoaEvent( (void *) v27, &SOZE_S_D_Event1_sc );
    Escher_SendEvent( event30 );

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    unsigned long * event_2621441_parm_ids = 0;
    const c_t ** event_2621441_parm_values = 0;
const c_t ** event_2621441_oal = 0;
    ROX_TMProtocol_Notify_Generate_Object_Event_Instance( 31, DomainID_SOZE, 2621445, 2621441, ( unsigned long ) v27, ( unsigned long ) event30, "ope", 0, event_2621441_parm_ids, event_2621441_parm_values, event_2621441_oal );
  } /* end debug scope */
#endif
  }
#ifdef ROX_TM_ENABLED
  { /* debug scope */
  ROX_TMProtocol_Notify_Function_Exit( 33, DomainID_SOZE, 524290, ( funcinv_id == 0 ) ? 1 : 0 );
  funcinv_id = 0;
  } /* end debug scope */
#endif

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Notify_Function_Exit( 34, 35828, 524290, 1 );
#endif
}


/*****************************************************************************
 * Domain Function:  Stop
 ****************************************************************************/
/* Declare deferred routine for posting.  */
static void SOZE_Stop_deferred( void );

void
SOZE_Stop( void )
{
  ul_t ilbargs = (ul_t)  InterleaveBridge( SOZE_Stop_deferred );
#ifdef ROX_TM_ENABLED
  funcinv_id = (ul_t) ilbargs;
  {unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;
  ROX_TMProtocol_Notify_Async_Function_Pending( DomainID_SOZE, 524291, funcinv_id, 0, func_parm_ids, func_parm_values );
  }
#endif
}

#ifdef ROX_TM_ENABLED
void
SOZE_Stop_debug( void )
{
  ul_t ilbargs = (ul_t) InterleaveBridge( SOZE_Stop_deferred );
#ifdef ROX_TM_ENABLED
  funcinv_id = (ul_t) ilbargs;
  {unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;
  ROX_TMProtocol_Notify_Async_Function_Pending( DomainID_SOZE, 524291, funcinv_id, 0, func_parm_ids, func_parm_values );
  }
#endif
}
#endif

static void
SOZE_Stop_deferred( void )
{
#ifdef ROX_TM_ENABLED
  funcinv_id = (unsigned long) GetILBData();
  ROX_TMProtocol_Notify_Async_Function_Executing( DomainID_SOZE, 524291, funcinv_id );
#endif
  SOZE_Stop_sync();
}

void
SOZE_Stop_sync( void )
{
  SOZE_S_D_s * v35;  /* ope */
#ifdef ROX_TM_ENABLED
  { /* debug scope */
  unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;  ROX_TMProtocol_Notify_Function_Entry( 40, DomainID_SOZE, 524291, funcinv_id, 0, func_parm_ids, func_parm_values );
  } /* end debug scope */
#endif

  /* SELECT ANY ope FROM INSTANCES OF S_D */
  v35 = (SOZE_S_D_s *) Escher_SetGetAny( &pG_SOZE_S_D_extent );

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Log_Select_from_execution( 36, "ANY", "S_D", TRUE, "ope" );
#endif

  /* ASSIGN ope.status = FALSE */
  v35->m_status = false;

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    c_t m_status_string_rep[2];
    sprintf( m_status_string_rep, "%u", v35->m_status );
  
    ROX_TMProtocol_Notify_Modify_Attribute( 37, DomainID_SOZE, 1048580, ( unsigned long ) v35, 1048601, "ope", m_status_string_rep, "FALSE" );
  } /* end debug scope */
#endif

  /* GENERATE S_D2:'~'() TO ope */
  {
    OoaEvent_t * event38 = Escher_NewOoaEvent( (void *) v35, &SOZE_S_D_Event2_sc );
    Escher_SendEvent( event38 );

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    unsigned long * event_2621442_parm_ids = 0;
    const c_t ** event_2621442_parm_values = 0;
const c_t ** event_2621442_oal = 0;
    ROX_TMProtocol_Notify_Generate_Object_Event_Instance( 39, DomainID_SOZE, 2621445, 2621442, ( unsigned long ) v35, ( unsigned long ) event38, "ope", 0, event_2621442_parm_ids, event_2621442_parm_values, event_2621442_oal );
  } /* end debug scope */
#endif
  }
#ifdef ROX_TM_ENABLED
  { /* debug scope */
  ROX_TMProtocol_Notify_Function_Exit( 41, DomainID_SOZE, 524291, ( funcinv_id == 0 ) ? 1 : 0 );
  funcinv_id = 0;
  } /* end debug scope */
#endif

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Notify_Function_Exit( 42, 35828, 524291, 1 );
#endif
}


/*****************************************************************************
 * Domain Function:  touch
 ****************************************************************************/
/* Declare deferred routine for posting.  */
static void SOZE_touch_deferred( void );

void
SOZE_touch( void )
{
  ul_t ilbargs = (ul_t)  InterleaveBridge( SOZE_touch_deferred );
#ifdef ROX_TM_ENABLED
  funcinv_id = (ul_t) ilbargs;
  {unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;
  ROX_TMProtocol_Notify_Async_Function_Pending( DomainID_SOZE, 524292, funcinv_id, 0, func_parm_ids, func_parm_values );
  }
#endif
}

#ifdef ROX_TM_ENABLED
void
SOZE_touch_debug( void )
{
  ul_t ilbargs = (ul_t) InterleaveBridge( SOZE_touch_deferred );
#ifdef ROX_TM_ENABLED
  funcinv_id = (ul_t) ilbargs;
  {unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;
  ROX_TMProtocol_Notify_Async_Function_Pending( DomainID_SOZE, 524292, funcinv_id, 0, func_parm_ids, func_parm_values );
  }
#endif
}
#endif

static void
SOZE_touch_deferred( void )
{
#ifdef ROX_TM_ENABLED
  funcinv_id = (unsigned long) GetILBData();
  ROX_TMProtocol_Notify_Async_Function_Executing( DomainID_SOZE, 524292, funcinv_id );
#endif
  SOZE_touch_sync();
}

void
SOZE_touch_sync( void )
{
  SOZE_S_B_s * v43;  /* bamboo */
#ifdef ROX_TM_ENABLED
  { /* debug scope */
  unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;  ROX_TMProtocol_Notify_Function_Entry( 47, DomainID_SOZE, 524292, funcinv_id, 0, func_parm_ids, func_parm_values );
  } /* end debug scope */
#endif

  /* SELECT ANY bamboo FROM INSTANCES OF S_B */
  v43 = (SOZE_S_B_s *) Escher_SetGetAny( &pG_SOZE_S_B_extent );

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Log_Select_from_execution( 44, "ANY", "S_B", TRUE, "bamboo" );
#endif

  /* GENERATE S_B4:'鐅ȂȂ'() TO bamboo */
  {
    OoaEvent_t * event45 = Escher_NewOoaEvent( (void *) v43, &SOZE_S_B_Event4_sc );
    Escher_SendEvent( event45 );

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    unsigned long * event_1572868_parm_ids = 0;
    const c_t ** event_1572868_parm_values = 0;
const c_t ** event_1572868_oal = 0;
    ROX_TMProtocol_Notify_Generate_Object_Event_Instance( 46, DomainID_SOZE, 1572867, 1572868, ( unsigned long ) v43, ( unsigned long ) event45, "bamboo", 0, event_1572868_parm_ids, event_1572868_parm_values, event_1572868_oal );
  } /* end debug scope */
#endif
  }
#ifdef ROX_TM_ENABLED
  { /* debug scope */
  ROX_TMProtocol_Notify_Function_Exit( 48, DomainID_SOZE, 524292, ( funcinv_id == 0 ) ? 1 : 0 );
  funcinv_id = 0;
  } /* end debug scope */
#endif

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Notify_Function_Exit( 49, 35828, 524292, 1 );
#endif
}


/*****************************************************************************
 * Domain Function:  leave
 ****************************************************************************/
/* Declare deferred routine for posting.  */
static void SOZE_leave_deferred( void );

void
SOZE_leave( void )
{
  ul_t ilbargs = (ul_t)  InterleaveBridge( SOZE_leave_deferred );
#ifdef ROX_TM_ENABLED
  funcinv_id = (ul_t) ilbargs;
  {unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;
  ROX_TMProtocol_Notify_Async_Function_Pending( DomainID_SOZE, 524293, funcinv_id, 0, func_parm_ids, func_parm_values );
  }
#endif
}

#ifdef ROX_TM_ENABLED
void
SOZE_leave_debug( void )
{
  ul_t ilbargs = (ul_t) InterleaveBridge( SOZE_leave_deferred );
#ifdef ROX_TM_ENABLED
  funcinv_id = (ul_t) ilbargs;
  {unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;
  ROX_TMProtocol_Notify_Async_Function_Pending( DomainID_SOZE, 524293, funcinv_id, 0, func_parm_ids, func_parm_values );
  }
#endif
}
#endif

static void
SOZE_leave_deferred( void )
{
#ifdef ROX_TM_ENABLED
  funcinv_id = (unsigned long) GetILBData();
  ROX_TMProtocol_Notify_Async_Function_Executing( DomainID_SOZE, 524293, funcinv_id );
#endif
  SOZE_leave_sync();
}

void
SOZE_leave_sync( void )
{
  SOZE_S_B_s * v50;  /* bamboo */
#ifdef ROX_TM_ENABLED
  { /* debug scope */
  unsigned long * func_parm_ids = 0;
  const c_t ** func_parm_values = 0;  ROX_TMProtocol_Notify_Function_Entry( 54, DomainID_SOZE, 524293, funcinv_id, 0, func_parm_ids, func_parm_values );
  } /* end debug scope */
#endif

  /* SELECT ANY bamboo FROM INSTANCES OF S_B */
  v50 = (SOZE_S_B_s *) Escher_SetGetAny( &pG_SOZE_S_B_extent );

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Log_Select_from_execution( 51, "ANY", "S_B", TRUE, "bamboo" );
#endif

  /* GENERATE S_B2:''() TO bamboo */
  {
    OoaEvent_t * event52 = Escher_NewOoaEvent( (void *) v50, &SOZE_S_B_Event2_sc );
    Escher_SendEvent( event52 );

#ifdef ROX_TM_ENABLED
  { /* debug scope */
    unsigned long * event_1572866_parm_ids = 0;
    const c_t ** event_1572866_parm_values = 0;
const c_t ** event_1572866_oal = 0;
    ROX_TMProtocol_Notify_Generate_Object_Event_Instance( 53, DomainID_SOZE, 1572867, 1572866, ( unsigned long ) v50, ( unsigned long ) event52, "bamboo", 0, event_1572866_parm_ids, event_1572866_parm_values, event_1572866_oal );
  } /* end debug scope */
#endif
  }
#ifdef ROX_TM_ENABLED
  { /* debug scope */
  ROX_TMProtocol_Notify_Function_Exit( 55, DomainID_SOZE, 524293, ( funcinv_id == 0 ) ? 1 : 0 );
  funcinv_id = 0;
  } /* end debug scope */
#endif

#ifdef ROX_TM_ENABLED
  ROX_TMProtocol_Notify_Function_Exit( 56, 35828, 524293, 1 );
#endif
}


