/*****************************************************************************
 * File:  sys_init.c
 *
 * Description:
 * Main entrance and parameters of the wild thing...
 *
 * Notice:
 *   (C) Copyright 1999-2003 ROX Software, Inc.
 *   All rights reserved.
 *
 * Model Compiler:  MC3020 V3.3.0
 * Serial Number:   302033003113005
 *
 * Warnings:
 *   !!! THIS IS AN AUTO-GENERATED FILE. PLEASE DO NOT EDIT. !!!
 ****************************************************************************/

#include "sys_init.h"
#include "sys_mechs.h"
#include "sys_events.h"
#include "sys_sets.h"
#include "sys_user_co.h"
#ifdef ROX_TM_ENABLED
#include "tm_layer.h"
#endif
#include "SOZE_dom_init.h"
#ifdef ROX_TM_ENABLED
#include "tm_protocol.h"
#include "tm_socket.h"    /* low level DebugMonitor interface  */
#endif



bool Escher_run_flag = true;
static Escher_InstanceHandle_t Escher_self;

/*****************************************************************************
 * main
 ****************************************************************************/
void entry_task ( VP_INT exinf )
{
  /***************************************************************************
   * system-level domain dispatcher table
   * This table contains pointers to dispatcher tables for each of
   * the OOA domains generated for this system.
   **************************************************************************/
  static const DomainDispatcher_t DomainDispatcherTable[ 2 ] =
  {
    0,
    SOZE_DomainDispatcher
  };


  OoaEvent_t * event;
  /* Execute user supplied system initialization.  */
  UserInitializationCallout();

  /* Execute generated system initialization phase.  */
  SystemLevelInitialization();
  /* Execute OOA domain specific initialization phase(s).  */
  ApplicationLevelInitialization();

#ifdef ROX_TM_ENABLED
  DebugMonitor_init( "localhost", 3593, &PROT_handle_message );
  DebugMonitor_process();
#endif
  /* Execute application analysis initialization phase(s).  */
  UserPreOoaInitializationCallout();  /* User supplied pre-init.  */
  RunApplicationInitSequence();      /* OOA init object actions.  */
  UserPostOoaInitializationCallout(); /* User supplied post-init.  */

  /* Start consuming events and dispatching background processes.  */
  while ( Escher_run_flag == true )
  {
    /* Dispatch an OOA self directed event.  */
    if ( ( event = DequeueOoaSelfEvent() ) != 0 )
    {
      /* Set up self reference for use by prioritized events (and others).  */
      Escher_self = GetEventTargetInstance( event );
#ifdef ROX_TM_ENABLED
      /* Notify the model debugger that we are about to run some action.  */
      ROX_TMProtocol_Notify_Activity_Pending( "Event Dispatch" );
#endif

      ( *DomainDispatcherTable[ GetEventDestDomainNumber( event ) ] )( event );
      if ( GetIsPolyEventInFlight( event ) == 0 )
      {
        Escher_DeleteOoaEvent( event );
      }
      sig_sem(SEM_MAIN);			/* Wake up main process */
    }  /* end self */
    else
    /* Dispatch one OOA non-self directed event.  */
    if ( ( event = DequeueOoaNonSelfEvent() ) != 0 )
    {
      /* Set up self reference for use by prioritized events (and others).  */
      Escher_self = GetEventTargetInstance( event );
#ifdef ROX_TM_ENABLED
      /* Notify the model debugger that we are about to run some action.  */
      ROX_TMProtocol_Notify_Activity_Pending( "Event Dispatch" );
#endif

      ( *DomainDispatcherTable[ GetEventDestDomainNumber( event ) ] )( event );
      if ( GetIsPolyEventInFlight( event ) == 0 )
      {
        Escher_DeleteOoaEvent( event );
      }
      sig_sem(SEM_MAIN);			/* Wake up main process */
    }  /* end non-self */
    else
    {
    } /* nop empty else (MISRA-C) */

    if(wai_sem(SEM_MAIN) < E_OK)
    {
      syslog_0(LOG_NOTICE, "Main Dispatch Semaphore Wait Error!");
    }

    /* Clear self when not in normal state action.    */
    Escher_self = 0;

    /* Launch (interrupt) bridge actions that occurred during state.  */
    DispatchInterleaveBridge();
#ifdef ROX_TM_ENABLED
  /* Go check for a message from the host.  Process if one exists.  */
  DebugMonitor_receive();
#endif

    /* User supplied background processing callout. */
    UserBackgroundProcessingCallout();
  }

  /* Shutdown phasing */
  UserPreShutdownCallout()
  ApplicationLevelShutdown();
#ifdef ROX_TM_ENABLED
  /* Shut down the target monitor.  Receive no more messages.  */
  ROX_TMProtocol_Notify_Target_Shutdown();
  ROX_TMProtocol_Session_Done();
  DebugMonitor_shutdown();
#endif

  SystemLevelShutdown();
  UserPostShutdownCallout()

  /* not return value */
}

/*****************************************************************************
 * Escher_GetSelf:  Access the reference to event target instance.
 ****************************************************************************/
void *
Escher_GetSelf( void )
{
  return Escher_self;
}
 
/*****************************************************************************
 * SystemLevelInitialization
 ****************************************************************************/
void
SystemLevelInitialization( void )
{
  /* Initialize the container pool. */
  Escher_SetFactoryInit();

  /* Initialize OOA event pool and queues. */
  InitializeOoaEventPool();
  InitializeOoaNonSelfEventQueue();
  InitializeOoaSelfEventQueue();
}

/*****************************************************************************
 * ApplicationLevelInitialization
 ****************************************************************************/
void
ApplicationLevelInitialization( void )
{
   /* Initialize all the domains */
  InitializeDomain_SOZE();
}

/*****************************************************************************
 * SystemLevelShutdown
 ****************************************************************************/
void
SystemLevelShutdown( void )
{}

/*****************************************************************************
 * ApplicationLevelShutdown
 ****************************************************************************/
void
ApplicationLevelShutdown( void )
{
   /* Shutdown all the domains */
  ShutdownDomain_SOZE();
}

typedef void ( * interleaved_bridge_t )( void );
static interleaved_bridge_t interleaved_bridges[ SYS_MAX_INTERLEAVED_BRIDGES ];
typedef struct { u1_t space[ SYS_MAX_INTERLEAVED_BRIDGE_DATA ]; } ilb_data_t;
static ilb_data_t ilb_data[ SYS_MAX_INTERLEAVED_BRIDGES ];
static u1_t ilb_head = 0;
static u1_t ilb_tail = 0;
static bool ilb_empty = true;
/*****************************************************************************
 * InterleaveBridge
 * Post a bridge routine for execution after any executing state
 * action completes.
 * Protect the data structures from being clobbered by another context
 * by disabling interrupts around the data access.
 * Return a pointer to the argument data used by this bridge operation.
 ****************************************************************************/
void *
InterleaveBridge( void (vfp)(void) )
{
  void * ilb = 0;
  /* disable interrupts */
  if ( ( ilb_head == ilb_tail ) && ( !ilb_empty ) ) {
    /* Overflowed array of interleaved bridges.  */
    UserInterleavedBridgeOverflowCallout();
  } else {
    ilb_empty = false;
    ilb = (void *) &ilb_data[ ilb_head ];
    interleaved_bridges[ ilb_head ] = vfp;
    /* Bump the head of the circular list.  */
    ilb_head = ( ilb_head == (SYS_MAX_INTERLEAVED_BRIDGES - 1) ) ? 0 : ilb_head + 1;
  }
  /* enable interrupts */
  sig_sem(SEM_MAIN);			/* Wake up main process */
  return ilb;
}

/*****************************************************************************
 * DispatchInterleaveBridge
 * Sequentially execute each of the bridge routines that have been
 * posted during the most recent executing state action.
 * Protect the data structures from being clobbered by another context
 * by disabling interrupts around the data access.
 ****************************************************************************/
void
DispatchInterleaveBridge( void )
{
  /* disable interrupts */
  if ( ! ilb_empty ) {
    do {
      /* enable interrupts */
      interleaved_bridges[ ilb_tail ]();  /* Run with interrupts enabled.  */
      /* disable interrupts */
      /* Bump the tail of the circular list.  */
      ilb_tail = ( ilb_tail == (SYS_MAX_INTERLEAVED_BRIDGES - 1) ) ? 0 : ilb_tail + 1;
    } while ( ilb_head != ilb_tail );
    ilb_empty = true;
  }
  /* enable interrupts */
}

/*****************************************************************************
 * Get a pointer to the data for the current interleaved bridge.
 ****************************************************************************/
void *
GetILBData( void )
{ return (void *) &ilb_data[ ilb_tail ]; }
