/*---------------------------------------------------------------------------
 * File:  tm_msghandlers.c
 *
 * Description:
 * This file contains individual message handlers for messages from
 * the UML Debugger.
 *
 *
 * Notice:
 *   (C) Copyright 1999-2003 ROX Software, Inc.
 *   All rights reserved.
 *
 * Model Compiler:  MC3020 V3.3.0
 * Serial Number:   302033003113005
 *
 * Warnings:
 *   !!! THIS IS AN AUTO-GENERATED FILE. PLEASE DO NOT EDIT. !!!
 *--------------------------------------------------------------------------*/
#ifdef ROX_TM_ENABLED
#include <stdlib.h>
#include "sys_mechs.h"
#include "tm_msghandlers.h"
#include "tm_protocol.h"
#include "tm_pencode.h"
#include "tm_socket.h"
#include "tm_xmlparser.h"
#include "tm_layer.h"
#include "sys_debug.h"

extern bool Escher_run_flag;
extern system_sync_ID_mapping_t * system_sync_IDs[];
static c_t run_mode = 0;   /* Default run mode is 0 (state).  */
static c_t b[1];
static const u4_t domain_list[] = ROX_domain_IDs;

c_t
PROT_TM_run_mode( void )
{
  return run_mode;
}

/*-------------------------------------------------------------------*/
/* This message is sent to the TM after it has connected to the      */
/* UMLD.  The TM responds with Add Domain messages so that the       */
/* UMLD may load the XML domains into the DOM.                       */
/*-------------------------------------------------------------------*/
c_t *
PROT_TM_Begin_Session(
  void * buffer,
  u2_t message_number
)
{
  c_t * b1;
  u1_t i;
  static const c_t * const r[] = ROX_domain_xml;
  for ( i = 0; i < ( sizeof( r ) / sizeof( r[0] ) ); i++ ) {
    PROT_TM_Add_Domain_encode( &b1, domain_list[ i ], r[ i ] );
    DebugMonitor_send( b1, Escher_strlen( b1 ) );
    DebugMonitor_receive();    /* Get ACK from host.  */
    DebugMonitor_block();      /* Stay in blocking mode.  */
  }
  /* Send session ready.  */
  PROT_TM_Session_Ready_encode( &b1, "MC3020", "V3.3.0", "read-write", "1.1" );
  DebugMonitor_send( b1, Escher_strlen( b1 ) );
  /* Send run mode.  */
  PROT_TM_Notify_Modify_Run_Mode_encode( &b1, run_mode );
  DebugMonitor_send( b1, Escher_strlen( b1 ) );
  DebugMonitor_receive();      /* Wait on the go ahead to run.  */
  return 0;
}

c_t * PROT_TM_Start_Execution(
  void * buffer,
  u2_t message_number
)
{
  /* Turn off blocking until statement or state is finished.  */
  DebugMonitor_noblock();
  return b;
}

c_t * PROT_TM_End_Session(
  void * buffer,
  u2_t message_number
)
{
  ROX_TMProtocol_Session_Done();
  DebugMonitor_shutdown();
  return b;
}

c_t * PROT_TM_Request_Shutdown(
  void * buffer,
  u2_t message_number
)
{
  ROX_TMProtocol_Notify_Target_Shutdown();
  DebugMonitor_shutdown();
  Escher_run_flag = false;
  return b;
}

c_t * PROT_TM_Request_Modify_Run_Mode(
  void * buffer,
  u2_t message_number
)
{
  c_t * b1;
  run_mode = atoi( PROT_get_attribute_value( "run-mode" ) );
  PROT_TM_Notify_Modify_Run_Mode_encode( &b1, run_mode );
  DebugMonitor_send( b1, Escher_strlen( b1 ) );
  return b;
}

c_t * PROT_TM_Request_Event_Dispatch(
  void * buffer,
  u2_t message_number
)
{
  return b;
}

c_t * PROT_TM_Request_Function_Invocation(
  void * buffer,
  u2_t message_number
)
{
  u1_t i, j;
  u4_t dom, fun;
  dom = atol( PROT_get_attribute_value( "dom-id" ) );
  fun = atol( PROT_get_attribute_value( "sync-id" ) );
  /*------------------------------------------------------------*/
  /* Search for the domain.  Assume that domains are in same    */
  /* sequence as the synchronous services.                      */
  /*------------------------------------------------------------*/
  for ( i = 0; i < 200; i++ ) {
    if ( domain_list[ i ] == dom ) {
      break;
    }
  }
  for ( j = 0; j < 200; j++ ) {
    if ( (system_sync_IDs[ i ])[ j ].id == fun ) {
      (system_sync_IDs[ i ])[ j ].f();   /* Invoke the domain function.  */
      break;
    }
  }
  return b;
}

c_t * PROT_TM_Request_Create_Object_Instance(
  void * buffer,
  u2_t message_number
)
{
  return b;
}

c_t * PROT_TM_Request_Delete_Object_Instance(
  void * buffer,
  u2_t message_number
)
{
  return b;
}

c_t * PROT_TM_Request_Generate_Class_Event_Instance(
  void * buffer,
  u2_t message_number
)
{
  return b;
}

c_t * PROT_TM_Request_Generate_Object_Event_Instance(
  void * buffer,
  u2_t message_number
)
{
  return b;
}

c_t * PROT_TM_Request_Generate_Creation_Event_Instance(
  void * buffer,
  u2_t message_number
)
{
  return b;
}

c_t * PROT_TM_Request_Delete_Event_Instance(
  void * buffer,
  u2_t message_number
)
{
  return b;
}

c_t * PROT_TM_Request_Modify_Attribute(
  void * buffer,
  u2_t message_number
)
{
  return b;
}

c_t * PROT_TM_Request_Modify_Event_Data_Item(
  void * buffer,
  u2_t message_number
)
{
  return b;
}
#endif


