/*---------------------------------------------------------------------------
 * File:  tm_protocol.c
 *
 * Description:
 * This is the debug message dispatcher.  A table defines the understood
 * messages.  The specific handlers are dispatched.
 *
 *
 * Notice:
 *   (C) Copyright 1999-2003 ROX Software, Inc.
 *   All rights reserved.
 *
 * Model Compiler:  MC3020 V3.3.0
 * Serial Number:   302033003113005
 *
 * Warnings:
 *   !!! THIS IS AN AUTO-GENERATED FILE. PLEASE DO NOT EDIT. !!!
 *--------------------------------------------------------------------------*/
#ifdef ROX_TM_ENABLED
#include "sys_mechs.h"
#include "tm_protocol.h"
#include "tm_xmlparser.h"
#include "tm_msghandlers.h"

typedef c_t * (*PROT_message_handler)( void *, u2_t );

/*--------------------------------------------------------------------*/
/* Message and handler vector table.                                  */
/*--------------------------------------------------------------------*/
static struct {
  const c_t * const name;
  PROT_message_handler func;
} PROT_message_handler_table[] = 
{
  { "Begin Session", PROT_TM_Begin_Session },
  { "Start Execution", PROT_TM_Start_Execution },
  { "End Session", PROT_TM_End_Session },
  { "Request Shutdown", PROT_TM_Request_Shutdown },
  { "Request Modify Run Mode", PROT_TM_Request_Modify_Run_Mode },
  { "Request Event Dispatch", PROT_TM_Request_Event_Dispatch },
  { "Request Function Invocation", PROT_TM_Request_Function_Invocation },
  { "Request Create Object Instance", PROT_TM_Request_Create_Object_Instance },
  { "Request Delete Object Instance", PROT_TM_Request_Delete_Object_Instance },
  { "Request Generate Class Event Instance", PROT_TM_Request_Generate_Class_Event_Instance },
  { "Request Generate Object Event Instance", PROT_TM_Request_Generate_Object_Event_Instance },
  { "Request Generate Creation Event Instance", PROT_TM_Request_Generate_Creation_Event_Instance },
  { "Request Delete Event Instance", PROT_TM_Request_Delete_Event_Instance },
  { "Request Modify Attribute", PROT_TM_Request_Modify_Attribute },
  { "Request Modify Event Data Item", PROT_TM_Request_Modify_Event_Data_Item }
};

#define NUM_OF_MESSAGES   sizeof(PROT_message_handler_table) / sizeof(PROT_message_handler_table[0])

/*------------------------------------------------------------------------*/
/* Parse a message, look up in the table and dispatch the handler.        */
/*------------------------------------------------------------------------*/
void PROT_handle_message(
  const char * p_message
)
{
  c_t first_message_name[42];
  c_t *next_message_name;
  c_t buffer[ 500 ];
  void *message_data = buffer;
  PROT_message_handler mh = 0;
  u2_t i, cmd, num_cmds;

  /* Get the message name and data.  */
  num_cmds = PROT_parse_message( p_message, first_message_name, &message_data );
  next_message_name = first_message_name;

  /*----------------------------------------------------------------------*/
  /* Loop through dispatching each received message.                      */
  /*----------------------------------------------------------------------*/
  for ( cmd = 0; cmd < num_cmds; ++cmd ) {
    for ( i = 0; i < NUM_OF_MESSAGES; ++i ) {
      if ( Escher_strcmp( next_message_name, PROT_message_handler_table[i].name ) == 0 ) {
        mh = PROT_message_handler_table[i].func;
        break;
      }
    }
    if ( mh == 0 ) {
      return; /* unknown message */
    } else {
      next_message_name = (*mh) ( message_data, cmd );
    }
  }
}
#endif


