/*****************************************************************************
 * File: sys_user_co.h
 *
 * Description:
 * Function declarations for user supplied (non-translated) call out entry
 * points in the generated application.
 *
 * Model Compiler:  302033003113005
 *
 * Enhancements provided by TOYO Corporation.
 *
 * Notice:
 *   (C) Copyright 1999-2003 ROX Software, Inc.
 *   All rights reserved.
 *
 * Model Compiler:  MC3020 V3.3.0
 * Serial Number:   302033003113005
 *
 * Warnings:
 *   !!! THIS IS AN AUTO-GENERATED FILE. PLEASE DO NOT EDIT. !!!
 ****************************************************************************/

#ifndef SYS_USER_CO_H
#define SYS_USER_CO_H

#ifdef	__cplusplus
extern "C" {
#endif

#include "sys_types.h"
#include "TIM_bridge.h"

/*****************************************************************************
 * UserInitializationCallout
 *
 * This function is invoked at the immediate begining of application
 * initialization. It is the very first function to be executed at system
 * startup.
 * User supplied implementation of this function should be restricted to
 * things like memory initialization, early hardware duties, etc.
 *
 ****************************************************************************/
extern void UserInitializationCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserInitializationCallout()

#ifndef UserInitializationCallout
#define UserInitializationCallout() UserInitializationCalloutf();
#endif

/*****************************************************************************
 * UserPreOoaInitializationCallout
 *
 * This function is invoked immediately prior to executing any OOA application
 * analysis initialization objects.
 *
 ****************************************************************************/
extern void UserPreOoaInitializationCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserPreOoaInitializationCallout()

#ifndef UserPreOoaInitializationCallout
#define UserPreOoaInitializationCallout() UserPreOoaInitializationCalloutf();
#endif

/*****************************************************************************
 * UserPostOoaInitializationCallout
 *
 * This function is invoked immediately after executing any OOA application
 * analysis initialization objects.
 * When this callout function returns, the system dispatcher will allow the
 * OOA application analysis state models to start consuming events.
 *
 ****************************************************************************/
extern void UserPostOoaInitializationCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserPostOoaInitializationCallout()

#ifndef UserPostOoaInitializationCallout
#define UserPostOoaInitializationCallout() UserPostOoaInitializationCalloutf();
#endif

/*****************************************************************************
 * UserBackgroundProcessingCallout
 *
 * This function is invoked once during each loop execution of the system
 * dispather.
 * It is invoked at the 'top' of the system dispatcher loop, immediately
 * prior to dispatching any OOA application analysis events.
 *
 ****************************************************************************/
extern void UserBackgroundProcessingCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserBackgroundProcessingCallout()

#ifndef UserBackgroundProcessingCallout
#define UserBackgroundProcessingCallout() UserBackgroundProcessingCalloutf();
#endif

/*****************************************************************************
 * UserPreShutdownCallout
 *
 * This function is invoked at termination of the system dispatcher, but
 * prior to performing any OOA application analysis shutdown sequencing.
 *
 ****************************************************************************/
extern void UserPreShutdownCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserPreShutdownCallout()

#ifndef UserPreShutdownCallout
#define UserPreShutdownCallout() UserPreShutdownCalloutf();
#endif

/*****************************************************************************
 * UserPostShutdownCallout
 *
 * This function is invoked immediately before application exit.
 *
 ****************************************************************************/
extern void UserPostShutdownCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserPostShutdownCallout()

#ifndef UserPostShutdownCallout
#define UserPostShutdownCallout() UserPostShutdownCalloutf();
#endif

/*****************************************************************************
 * UserEventCantHappenCallout
 *
 * This function is invoked any time that an event is received that
 * results in a "cant happen" transition.
 *
 ****************************************************************************/
extern void UserEventCantHappenCalloutf( const Escher_StateNumber_t,
                                         const Escher_StateNumber_t,
                                         const Escher_EventNumber_t );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserEventCantHappenCallout( s1, s2, e )

#ifndef UserEventCantHappenCallout
#define UserEventCantHappenCallout( s1, s2, e ) UserEventCantHappenCalloutf( s1, s2, e );
#endif

/*****************************************************************************
 * UserEventNoInstanceCallout
 *
 * This function is invoked when we failed to validate the instance
 * to which an event was directed.  This can happen in normal operation
 * when the instance was deleted while the event was in flight (analysis
 * error).
 *
 ****************************************************************************/
extern void UserEventNoInstanceCalloutf( const Escher_EventNumber_t );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserEventNoInstanceCallout( e )

#ifndef UserEventNoInstanceCallout
#define UserEventNoInstanceCallout( e ) UserEventNoInstanceCalloutf( e );
#endif

/*****************************************************************************
 * UserEventFreeListEmptyCallout
 *
 * This function is invoked when an attempt is made to allocate an
 * event, but there are no more left.
 *
 ****************************************************************************/
extern void UserEventFreeListEmptyCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserEventFreeListEmptyCallout()

#ifndef UserEventFreeListEmptyCallout
#define UserEventFreeListEmptyCallout() UserEventFreeListEmptyCalloutf();
#endif

/*****************************************************************************
 * UserEmptyHandleDetectedCallout
 *
 * This function is invoked when an attempt is made to use an instance
 * reference variable (handle) that is null (empty).
 *
 ****************************************************************************/
extern void UserEmptyHandleDetectedCalloutf( c_t *, c_t * );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserEmptyHandleDetectedCallout( s1, s2 )

#ifndef UserEmptyHandleDetectedCallout
#define UserEmptyHandleDetectedCallout( s1, s2 ) UserEmptyHandleDetectedCalloutf( s1, s2 );
#endif

/*****************************************************************************
 * UserObjectPoolEmptyCallout
 *
 * This function is invoked when an attempt is made to create an
 * instance of an object, but there are no instances available.
 *
 ****************************************************************************/
extern void UserObjectPoolEmptyCalloutf( c_t *, c_t * );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserObjectPoolEmptyCallout( s1, s2 )

#ifndef UserObjectPoolEmptyCallout
#define UserObjectPoolEmptyCallout( s1, s2 ) UserObjectPoolEmptyCalloutf( s1, s2 );
#endif

/*****************************************************************************
 * UserNodeListEmptyCallout
 *
 * This function is invoked when an attempt is made to allocate a
 * node, but there are no more left.
 *
 ****************************************************************************/
extern void UserNodeListEmptyCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserNodeListEmptyCallout()

#ifndef UserNodeListEmptyCallout
#define UserNodeListEmptyCallout() UserNodeListEmptyCalloutf();
#endif

/*****************************************************************************
 * UserInterleavedBridgeOverflowCallout
 *
 * This function is invoked when an attempt is made to post too many
 * interleaved bridges.  The depth of this list is defined by
 * SYS_MAX_INTERLEAVED_BRIDGES (unless changed in the archetype).
 *
 ****************************************************************************/
extern void UserInterleavedBridgeOverflowCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserInterleavedBridgeOverflowCallout()

#ifndef UserInterleavedBridgeOverflowCallout
#define UserInterleavedBridgeOverflowCallout() UserInterleavedBridgeOverflowCalloutf();
#endif

/*****************************************************************************
 * UserSelfEventQueueEmptyCallout
 *
 * This function is invoked when the events to self queue is
 * interrogated and found to be empty.
 *
 ****************************************************************************/
extern void UserSelfEventQueueEmptyCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserSelfEventQueueEmptyCallout()

#ifndef UserSelfEventQueueEmptyCallout
#define UserSelfEventQueueEmptyCallout() UserSelfEventQueueEmptyCalloutf();
#endif

/*****************************************************************************
 * UserNonSelfEventQueueEmptyCallout
 *
 * This function is invoked when the events to instance queue is
 * interrogated and found to be empty.
 *
 ****************************************************************************/
extern void UserNonSelfEventQueueEmptyCalloutf( void );
/* The following empty definition renders the callout hook invisible.
   Delete or comment out the following define to activate the in line
   hook for this callout.  */
#define UserNonSelfEventQueueEmptyCallout()

#ifndef UserNonSelfEventQueueEmptyCallout
#define UserNonSelfEventQueueEmptyCallout() UserNonSelfEventQueueEmptyCalloutf();
#endif


#ifdef	__cplusplus
}
#endif

#endif  /* SYS_USER_CO_H */
