/*****************************************************************************
 * File: rox_trace.h
 *
 * Description:
 *  Run time instrumentation and debugging declarations
 *
 * Model Compiler:  302033003113005
 *
 * Enhancements provided by TOYO Corporation.
 *
 * Notice:
 *   (C) Copyright 1999-2003 ROX Software, Inc.
 *   All rights reserved.
 *
 * Model Compiler:  MC3020 V3.3.0
 * Serial Number:   302033003113005
 *
 * Warnings:
 *   !!! THIS IS AN AUTO-GENERATED FILE. PLEASE DO NOT EDIT. !!!
 ****************************************************************************/

#ifndef ROX_TRACE_H
#define ROX_TRACE_H

#ifdef	__cplusplus
extern "C" {
#endif


/*****************************************************************************
 * State transition start tracing:
 *
 ****************************************************************************/
/* To suppress transition source identification, uncomment the following macro */
/* #define ROX_TXN_START_PROLOGUE */
#define ROX_TXN_START_PROLOGUE

#ifndef ROX_TXN_START_PROLOGUE
#define ROX_TXN_START_PROLOGUE printf( "%s #%5u: ", __FILE__, __LINE__ );
#endif

/* To suppress state transition start tracing, uncomment the following macro */
/* #define ROX_STATE_TXN_START_TRACE( obj_kl, state_num, state_name ) */

#ifndef ROX_STATE_TXN_START_TRACE
#define ROX_STATE_TXN_START_TRACE( obj_kl, state_num, state_name ) {   ROX_TXN_START_PROLOGUE   printf( "Transition started:  '%s' State [%u] '%s'\n", obj_kl, state_num, state_name ); }
#endif

/*****************************************************************************
 * State transition complete tracing:
 *
 ****************************************************************************/
/* To suppress state transition complete tracing, uncomment the following macro */
/* #define ROX_STATE_TXN_END_TRACE( obj_kl, state_num, state_name ) */

#ifndef ROX_STATE_TXN_END_TRACE
#define ROX_STATE_TXN_END_TRACE( obj_kl, state_num, state_name ) {   ROX_TXN_START_PROLOGUE   printf( "Transition complete: '%s' State [%u] '%s'\n", obj_kl, state_num, state_name ); }
#endif

/*****************************************************************************
 * Event ignored tracing:
 *
 ****************************************************************************/
/* To suppress event ignored tracing, uncomment the following macro */
/* #define ROX_STATE_TXN_IG_TRACE( obj_kl, state_num, state_name ) */

#ifndef ROX_STATE_TXN_IG_TRACE
#define ROX_STATE_TXN_IG_TRACE( obj_kl, state_num ) {   ROX_TXN_START_PROLOGUE   printf( "Event ignored: '%s' current_state = %u\n", obj_kl, state_num ); }
#endif

/*****************************************************************************
 * Transformer invocation start tracing:
 *
 ****************************************************************************/
/* To suppress transformer start tracing, uncomment the following macro */
/* #define ROX_TRANSFORMER_START_TRACE( obj_kl, tfr_name ) */

#ifndef ROX_TRANSFORMER_START_TRACE
#define ROX_TRANSFORMER_START_TRACE( obj_kl, tfr_name ) {   ROX_TXN_START_PROLOGUE   printf( "Invocation started: '%s' Transformer '%s'\n", obj_kl, tfr_name ); }
#endif

/*****************************************************************************
 * Transformer invocation complete tracing:
 *
 ****************************************************************************/
/* To suppress transformer end tracing, uncomment the following macro */
/* #define ROX_TRANSFORMER_END_TRACE( obj_kl, tfr_name ) */

#ifndef ROX_TRANSFORMER_END_TRACE
#define ROX_TRANSFORMER_END_TRACE( obj_kl, tfr_name ) {   ROX_TXN_START_PROLOGUE   printf( "Invocation complete: '%s' Transformer '%s'\n", obj_kl, tfr_name ); }
#endif

/*****************************************************************************
 * Object Action Language (OAL) statement level tracing:
 *
 * ROX_BPAL_STMT_PROLOGUE :
 * ROX_BPAL_STMT_INDENT :
 * ROX_BPAL_STMT_TRACE :
 ****************************************************************************/

/* To suppress statement source identification, uncomment the following macro */
/* #define ROX_BPAL_STMT_PROLOGUE */

#ifndef ROX_BPAL_STMT_PROLOGUE
#define ROX_BPAL_STMT_PROLOGUE printf( "%s #%5u: ", __FILE__, __LINE__ );
#endif

/* To suppress statement level indentation, uncomment the following macro */
/* #define ROX_BPAL_STMT_INDENT( blck_level ) */

#ifndef ROX_BPAL_STMT_INDENT
#define ROX_BPAL_STMT_INDENT( blck_level ) {  u1_t i; for ( i = 0; i < blck_level; i++ ) printf( "  " ); }
#endif

/* To suppress statement source identification, uncomment the following macro */
/* #define ROX_BPAL_STMT_TRACE( blck_level, stmt_action ) */

#ifndef ROX_BPAL_STMT_TRACE
#define ROX_BPAL_STMT_TRACE( blck_level, stmt_action ) {   ROX_BPAL_STMT_PROLOGUE   ROX_BPAL_STMT_INDENT( blck_level )   printf( "%s\n", stmt_action ); }
#endif

/* To suppress empty handle detection, modify the following macro.  */

#ifndef ROX_EMPTY_HANDLE_TRACE
#define ROX_EMPTY_HANDLE_TRACE( object_keyletters, s ) { UserEmptyHandleDetectedCallout( object_keyletters, s ) }
#endif

/*****************************************************************************
 ****************************************************************************/
typedef struct Escher_StateInfo_s Escher_StateInfo_s;
struct Escher_StateInfo_s
{
  Escher_StateNumber_t state_number;  /* 'Real' state number */
  u1_t *       state_name;    /* State name */
};

#ifdef	__cplusplus
}
#endif

#endif  /* ROX_TRACE_H */
