/*
 *  TOPPERS/JSP Rose-RT Link Programs
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Platform Development Center
 *                               RIOCH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: ir.c,v 1.0 2004/03/20 14:30:20 ken Exp $
 */

#include <t_services.h>
#include "kernel_id.h"
#include "oaks16mini.h"
#include "port.h"
#include "ir.h"

#define	IR_JUDGE_COUNT	280
#define	CHK_VALUE		2000

static ir_func ir_funcs[MAX_FUNC_NUM];
UB	ir_data;
UH  ir_count;
UH	ir_value;

/*======================================================================
 *  Irf[^̕ϊp\
========================================================================*/
struct IR_DATA_TABLE {
	UH	data;
	UB	c;
};

/*======================================================================
 *  Irf[^ϊe[uiSONYpj
========================================================================*/
static struct IR_DATA_TABLE const ir_tbl[] = {
	0x193a,	RUN,		/* SONY#1 mode 2 */
	0xf13a,	STOP,
	0x18ba,	RUN,		/* SONY#1 mode 3 */
	0xf0ba, STOP,
	0x59c0, RUN,		/* SONY#2 mode 2 */
	0x19c0, STOP,
	0x59a0, RUN,		/* SONY#2 mode 3 */
	0x19a0, STOP,
	0xac40, RUN,
	0x8c40, STOP
};

/*======================================================================
 *  Ir
========================================================================*/
void ir_init( void )
{
	int i;
	
	ir_data = 0;
	ir_count = 0;
	ir_value = 0;
	for (i = 0; i<MAX_FUNC_NUM; i++){
		ir_funcs[i] = NULL;
	}
}

/*========================================================================
 * IrCxgݒ肷
========================================================================*/
void set_ir_event(void (*func)(void), int type)
{
	ir_funcs[type] = func;
}

/*======================================================================
*  ֐Tv  F  IrphCo[^XN
*        F  exinf
*  ߂l    F  Ȃ
========================================================================*/
void ir_main( void )
{
	UH  d, c;
	int i, count;


	d = c = 0;
	i = 0;
	while(sense_port(IR1) == ON){
		i++;
		if(i > CHK_VALUE){
			return;
		}
	}
	i = 0;
	while(sense_port(IR1) == OFF){
		i++;
		if(i > CHK_VALUE){
			return;
		}
	}
	i = 0;
	while(i <= (CHK_VALUE/4)){
		loc_cpu();
		i = 0;
		do{
			i++;
		}while(sense_port(IR1) == ON);
		unl_cpu();
		if(c < 16 && i > IR_JUDGE_COUNT)
			d |= 1<<(15-c);
		i = 0;
		c++;
		while(sense_port(IR1) == OFF){
			i++;
			if(i > (CHK_VALUE/4))
				break;
		}
	}
	ir_count = c;
	ir_value = d;
	syslog_1(LOG_NOTICE, "ir_value = 0x%x", d);
	count = sizeof(ir_tbl) / sizeof(struct IR_DATA_TABLE);
	for(i = 0 ; i < count ; i++){
		if(ir_tbl[i].data == d){
			ir_data = ir_tbl[i].c;
			if(ir_funcs[ir_tbl[i].c])
				(*ir_funcs[ir_tbl[i].c])();
			break;
		}
	}
}

