/*
 *  TOPPERS/JSP Rose-RT Link Programs
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Platform Development Center
 *                               RIOCH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: port.c,v 1.0 2004/04/09 18:18:20 ken Exp $
 */

#include <t_services.h>
#include "port.h"
#include "ir.h"
#include "kernel_id.h"
#include "SOZE_sync_services.h"
#include "TIM_bridge.h"
#include "timer.h"

#ifdef S_DEBUG
#include "device.h"
#include "oaks16mini.h"
#else
#include <sil.h>
#ifdef OAKS16
#include "oaks16.h"
#else
#include "oaks16mini.h"
#endif
#endif

#define	DEVICE_NOACT	0	/* NOT ACTIVE */
#define	DEVICE_IRACT	1	/* IR ACTIVE */
#define	DEVICE_SEACT	2	/* SENSE ACTIVE */

#define	P8_BITS			(SW4|SW5|SS1)

/*
 *  MTYPE̐ݒɂ{[h^Cvݒ肷
 *  0      = ET2003Ńfs{[h
 *  ̑ = MOTOR̃I/It𔽓]
 */
#if BTYPE == 0
#define	MOTOR_ON	ON
#define	MOTOR_OFF	OFF
#else
#define	MOTOR_ON	OFF
#define	MOTOR_OFF	ON
#endif

static UB cled;
static UB current_p8;
static UB device_mode;
static UB blink_led_status;
static BOOL blink;
static UH int_count;

/*======================================================================
 *  |[g̏֐
======================================================================*/
void initial_port()
{
	sil_wrb_mem((VP)TADR_SFR_PD8, 0x00);	/* |[g8͐ݒ		*/
	sil_wrb_mem((VP)TADR_SFR_PUR2, 0x03);	/* P80P87vAbv	*/
	current_p8 = sil_reb_mem((VP)TADR_SFR_P8) & P8_BITS;

	cled = ~P7_LED1;						/* |[g7o͐ݒ      */
	sil_wrb_mem((VP)TADR_SFR_P7, cled);		/* |[g7f[^	*/
	sil_wrb_mem((VP)TADR_SFR_PD7, 0xff);	/* |[g7o͐ݒ		*/
	device_mode = DEVICE_NOACT;
	set_motor(0, 0);						/* [^[~			*/
	blink = FALSE;
	blink_led_status = OFF;
}

/*======================================================================
 *  |[gW̏Ԃo
 *  arg1:SW4,SW5,IR1,SS1
======================================================================*/
int sense_port(int id)
{
	UB sp8;

	sp8 = sil_reb_mem((VP)TADR_SFR_P8);
	if(sp8 & id)
		return OFF;
	else
		return ON;
}

/*======================================================================
 *  LED̏ԂZbg
======================================================================*/
void setup_led(int led, int req)
{
	if( req == BLINK )
		blink = TRUE;
	else if ( req == ON ) {
		blink = FALSE;
		set_led( led, ON );
	}
	else {
		blink = FALSE;
		set_led( led, OFF );
	}
}

/*======================================================================
 *  LED̐ݒs
 *  arg1:LED1܂LED2
 *  arg2:ON܂OFF
======================================================================*/
void set_led(int led, int req)
{
	volatile UB rled = cled;

	switch(led){
	case LED2:
		rled &= ~P7_LED2;
		if(req == OFF)
			rled |= P7_LED2;
		break;
	case LED3:
		rled &= ~P7_LED1;
		if(req == OFF)
			rled |= P7_LED1;
		break;
	default:
		break;
	}
	if(cled != rled){
		cled = rled;
		sil_wrb_mem((VP)TADR_SFR_P7, cled);
	}
}

/*======================================================================
 *  LED̓_łs
======================================================================*/
void blink_led(void)
{
	if( blink ){
		blink_led_status ^= ON;
		set_led( LED2, blink_led_status);
	}
}

/*======================================================================
 *  [^[̋NA~ݒ肷
 *  arg1:[^[ID
 *  arg2:ÑxAOŒ~
======================================================================*/
void set_motor(int id, int level)
{
	if(level == 0)
		set_led(LED3, MOTOR_ON);
	else
		set_led(LED3, MOTOR_OFF);
}

/*======================================================================
 *  XCb`AZT[^C~O֐
 *  25msԊuŌĂяos邱Ƃz肷
 *  ʂƂĕωP8ID̃rbgԂB
======================================================================*/
int sync_sense(void)
{
	UB wk;
	int result = 0;

	/* |[g8ǂݎ */
	wk = sil_reb_mem((VP)TADR_SFR_P8) & P8_BITS;
	if((current_p8 & SW4) != (wk & SW4)){
		if(wk & SW4){
			SOZE_Stop();
		}
		else{
			SOZE_Start();
		}
	}
#ifdef S_DEBUG
	if((current_p8 & SW5) != (wk & SW5)){
		if(wk & SW5)
#else
	if((current_p8 & SS1) != (wk & SS1)){
		if(!(wk & SS1))
#endif
			SOZE_touch();
		else
			SOZE_leave();
	}

	current_p8 = wk;
	return result;
}

/*======================================================================
 *  foCX^XN
======================================================================*/
void device_task(VP_INT exinf)
{
	syslog_1(LOG_INFO, "Sample1 device task starts (exinf = %d).", exinf);
	initial_port();						/* n[h̏	*/
	ir_init();							/* IR			*/

	for(;;){
		wai_sem(SEM_DEV);
		if(device_mode == DEVICE_IRACT){
			ir_main();					/* IRC			*/
			tslp_tsk(100);
		}
		else{
			sync_sense();				/* |[gZX		*/
			blink_led();				/* LED_			*/
		}
		device_mode = DEVICE_NOACT;
	}
}

/*======================================================================
 *  ^C}[
======================================================================*/
void timer_handler2(void)
{
	timer_handler();
	int_count++;
	if(device_mode == DEVICE_NOACT){
		if(sense_port(IR1) == ON){
			isig_sem(SEM_DEV);
			device_mode = DEVICE_IRACT;
		}
#ifdef S_DEBUG
		else {
#else
		else if(int_count > 200){
#endif
			isig_sem(SEM_DEV);
			device_mode = DEVICE_SEACT;
			int_count = 0;
		}
	}
}


