/*---------------------------------------------------------------------------
 * File:  tm_pencode.c
 *
 * Description:
 * This is the debug message dispatcher.  A table defined the understood
 * messages.  The specific handlers are dispatched.
 *
 *
 * Notice:
 *   (C) Copyright 1999-2003 ROX Software, Inc.
 *   All rights reserved.
 *
 * Model Compiler:  MC3020 V3.3.0
 * Serial Number:   302033003113005
 *
 * Warnings:
 *   !!! THIS IS AN AUTO-GENERATED FILE. PLEASE DO NOT EDIT. !!!
 * Based upon ptc_TMprotocol_encode.c (C) 2002 by Project Technology, Inc.
 *--------------------------------------------------------------------------*/
#ifdef ROX_TM_ENABLED
#include "tm_protocol.h"
#include "tm_pencode.h"

#include <time.h>    /* time, localtime, asctime */
#include <string.h>  /* strcpy, strcat */
#include <stdio.h>   /* sprintf */
#include <stdlib.h>  /* malloc, free */

static char *PROT_TM_xmlclean( const char *p_string)
{
    int loop, loop2, len, num_ampltgt;
    char *return_buffer;

    num_ampltgt = 0;
    len = strlen( p_string );
    for ( loop = 0; loop < len; ++ loop )
    {
      if ( p_string[loop] == '&' )
        num_ampltgt += 4;
      else if ( p_string[loop] == '<' )
        num_ampltgt += 3;
      else if ( p_string[loop] == '>' )
        num_ampltgt += 3;
      else if ( p_string[loop] == '\n' )
        num_ampltgt -= 1;
    }

    if ( num_ampltgt == 0 )
        return 0;

    return_buffer = (char *) malloc( len+num_ampltgt+1 );
    loop2 = 0;
    for ( loop = 0; loop < len; ++ loop )
    {
        if ( p_string[loop] == '&' )
        {
            return_buffer[loop2++] = '&';
            return_buffer[loop2++] = 'a';
            return_buffer[loop2++] = 'm';
            return_buffer[loop2++] = 'p';
            return_buffer[loop2++] = ';';
        }
        else if ( p_string[loop] == '<' )
        {
            return_buffer[loop2++] = '&';
            return_buffer[loop2++] = 'l';
            return_buffer[loop2++] = 't';
            return_buffer[loop2++] = ';';
        }
        else if ( p_string[loop] == '>' )
        {
            return_buffer[loop2++] = '&';
            return_buffer[loop2++] = 'g';
            return_buffer[loop2++] = 't';
            return_buffer[loop2++] = ';';
        }
        else if ( p_string[loop] == '\n' )
        {
            /* do nothing */
        }
        else
        {
            return_buffer[loop2++] = p_string[loop];
        }
    }
    return_buffer[loop2] = 0;
    return return_buffer;
}


static void PROT_TM_strcat( char **buffer, size_t *len, const char *str )
{
  size_t current_len = strlen( *buffer );
  size_t added_len = strlen( str );
  if ( (current_len + added_len) >= (*len - 2) )
  {
    char *new_buf;
    size_t new_size = *len * 2;
    while ( new_size < (current_len + added_len + 2) )
    {
        new_size *= 2;
    }
    new_buf = (char *) malloc( new_size );
    *len = new_size;
    strcpy ( new_buf, *buffer );
    free ( *buffer );
    *buffer = new_buf;
  }

  strcat( *buffer, str );
}

void PROT_TM_Notify_Modify_Run_Mode_encode( char **buffer, int run_mode )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Modify Run Mode\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " run-mode=\"" );
  sprintf( int_buffer, "%d", run_mode );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Add_Domain_encode( char **buffer, unsigned long dom_id, const char *xml_url )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_xml_url;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Add Domain\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<xml-url>" );
  clean_xml_url = PROT_TM_xmlclean( xml_url );
  if ( clean_xml_url )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_xml_url );
    free ( clean_xml_url );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, xml_url );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</xml-url>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Session_Ready_encode( char **buffer, const char *product, const char *version, const char *data, const char *protocol_version )
{
  struct tm *newtime;
  time_t long_time;
  char *clean_product;
  char *clean_version;
  char *clean_data;
  char *clean_protocol_version;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Session Ready\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<product>" );
  clean_product = PROT_TM_xmlclean( product );
  if ( clean_product )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_product );
    free ( clean_product );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, product );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</product>" );
  PROT_TM_strcat( buffer, &buffer_len, "<version>" );
  clean_version = PROT_TM_xmlclean( version );
  if ( clean_version )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_version );
    free ( clean_version );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, version );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</version>" );
  PROT_TM_strcat( buffer, &buffer_len, "<data>" );
  clean_data = PROT_TM_xmlclean( data );
  if ( clean_data )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_data );
    free ( clean_data );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, data );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</data>" );
  PROT_TM_strcat( buffer, &buffer_len, "<protocol-version>" );
  clean_protocol_version = PROT_TM_xmlclean( protocol_version );
  if ( clean_protocol_version )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_protocol_version );
    free ( clean_protocol_version );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, protocol_version );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</protocol-version>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Session_Done_encode( char **buffer )
{
  struct tm *newtime;
  time_t long_time;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Session Done\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Target_Shutdown_encode( char **buffer )
{
  struct tm *newtime;
  time_t long_time;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Target Shutdown\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Function_Exit_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sync_id, char oal_invoked )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Function Exit\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sync-id=\"" );
  sprintf( int_buffer, "%lu", sync_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " oal-invoked=\"" );
  sprintf( int_buffer, "%d", oal_invoked );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Create_Object_Instance_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long obj_inst_id, int is_implicit, const char *local_variable, int num_params, unsigned long attr_id[], const char *value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_local_variable;
  char *clean_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Create Object Instance\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " is-implicit=\"" );
  sprintf( int_buffer, "%d", is_implicit );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " attr-id=\"" );
    sprintf( int_buffer, "%lu", attr_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Create_Object_Instance_No_Variable_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long obj_inst_id, int num_params, unsigned long attr_id[], const char *value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Create Object Instance No Variable\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " attr-id=\"" );
    sprintf( int_buffer, "%lu", attr_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Creation_Transition_encode( char **buffer, int context, unsigned long dom_id, unsigned long obj_id, unsigned long obj_inst_id, int num_params, unsigned long attr_id[], const char *value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Creation Transition\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " attr-id=\"" );
    sprintf( int_buffer, "%lu", attr_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Modify_Attribute_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long obj_inst_id, unsigned long attr_id, const char *local_variable, const char *value, const char *oal_value )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_local_variable;
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Modify Attribute\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " attr-id=\"" );
  sprintf( int_buffer, "%lu", attr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<value>" );
  clean_value = PROT_TM_xmlclean( value );
  if ( clean_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_value );
    free ( clean_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  PROT_TM_strcat( buffer, &buffer_len, "<oal-value>" );
  clean_oal_value = PROT_TM_xmlclean( oal_value );
  if ( clean_oal_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
    free ( clean_oal_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, oal_value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Modify_Referential_Attribute_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long obj_inst_id, unsigned long attr_id, const char *value, const char *local_variable )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_value;
  char *clean_local_variable;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Modify Referential Attribute\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " attr-id=\"" );
  sprintf( int_buffer, "%lu", attr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<value>" );
  clean_value = PROT_TM_xmlclean( value );
  if ( clean_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_value );
    free ( clean_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Delete_Object_Instance_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long obj_inst_id, const char *local_variable )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_local_variable;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Delete Object Instance\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Generate_Class_Event_Instance_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sm_id, unsigned long smevt_id, unsigned long evt_inst_id, int num_params, unsigned long smedi_id[], const char *value[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Generate Class Event Instance\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Generate_Object_Event_Instance_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sm_id, unsigned long smevt_id, unsigned long obj_inst_id, unsigned long evt_inst_id, const char *local_variable, int num_params, unsigned long smedi_id[], const char *value[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_local_variable;
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Generate Object Event Instance\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Generate_Creation_Event_Instance_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long smevt_id, unsigned long evt_inst_id, int num_params, unsigned long smedi_id[], const char *value[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Generate Creation Event Instance\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Generate_Event_Variable_encode( char **buffer, int context, int stmt_id, const char *local_variable, unsigned long evt_inst_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_local_variable;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Generate Event Variable\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Generate_Event_Attribute_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long obj_inst_id, unsigned long attr_id, const char *local_variable, unsigned long evt_inst_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_local_variable;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Generate Event Attribute\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " attr-id=\"" );
  sprintf( int_buffer, "%lu", attr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Create_Class_Event_Instance_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sm_id, unsigned long smevt_id, unsigned long evt_inst_id, int is_implicit, const char *local_variable, int num_params, unsigned long smedi_id[], const char *value[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_local_variable;
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Create Class Event Instance\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " is-implicit=\"" );
  sprintf( int_buffer, "%d", is_implicit );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Create_Object_Event_Instance_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sm_id, unsigned long smevt_id, unsigned long obj_inst_id, unsigned long evt_inst_id, int is_implicit, const char *local_variable, const char *to_obj_inst_variable, int num_params, unsigned long smedi_id[], const char *value[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_local_variable;
  char *clean_to_obj_inst_variable;
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Create Object Event Instance\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " is-implicit=\"" );
  sprintf( int_buffer, "%d", is_implicit );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<to-obj-inst-variable>" );
  clean_to_obj_inst_variable = PROT_TM_xmlclean( to_obj_inst_variable );
  if ( clean_to_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_to_obj_inst_variable );
    free ( clean_to_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, to_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</to-obj-inst-variable>" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Create_Creation_Event_Instance_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long smevt_id, unsigned long evt_inst_id, int is_implicit, const char *local_variable, int num_params, unsigned long smedi_id[], const char *value[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_local_variable;
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Create Creation Event Instance\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " is-implicit=\"" );
  sprintf( int_buffer, "%d", is_implicit );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Modify_Event_Data_Item_encode( char **buffer, int context, unsigned long dom_id, unsigned long sm_id, unsigned long smevt_id, unsigned long evt_inst_id, unsigned long smedi_id, const char *value )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Modify Event Data Item\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
  sprintf( int_buffer, "%lu", smedi_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<value>" );
  clean_value = PROT_TM_xmlclean( value );
  if ( clean_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_value );
    free ( clean_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Delete_Event_Instance_encode( char **buffer, int context, unsigned long dom_id, unsigned long sm_id, unsigned long smevt_id, unsigned long evt_inst_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Delete Event Instance\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Function_Invocation_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sync_id, int num_params, unsigned long sparm_id[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Function Invocation\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sync-id=\"" );
  sprintf( int_buffer, "%lu", sync_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " sparm-id=\"" );
    sprintf( int_buffer, "%lu", sparm_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Async_Function_Pending_encode( char **buffer, unsigned long dom_id, unsigned long sync_id, unsigned long funcinv_id, int num_params, unsigned long sparm_id[], const char *value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Async Function Pending\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sync-id=\"" );
  sprintf( int_buffer, "%lu", sync_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " funcinv-id=\"" );
  sprintf( int_buffer, "%lu", funcinv_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " sparm-id=\"" );
    sprintf( int_buffer, "%lu", sparm_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Async_Function_Executing_encode( char **buffer, int context, unsigned long dom_id, unsigned long sync_id, unsigned long funcinv_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Async Function Executing\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sync-id=\"" );
  sprintf( int_buffer, "%lu", sync_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " funcinv-id=\"" );
  sprintf( int_buffer, "%lu", funcinv_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Function_Entry_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sync_id, unsigned long funcinv_id, int num_params, unsigned long sparm_id[], const char *value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Function Entry\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sync-id=\"" );
  sprintf( int_buffer, "%lu", sync_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " funcinv-id=\"" );
  sprintf( int_buffer, "%lu", funcinv_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " sparm-id=\"" );
    sprintf( int_buffer, "%lu", sparm_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Modify_Function_Parameter_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sync_id, unsigned long sparm_id, const char *value, const char *oal_value )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Modify Function Parameter\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sync-id=\"" );
  sprintf( int_buffer, "%lu", sync_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sparm-id=\"" );
  sprintf( int_buffer, "%lu", sparm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<value>" );
  clean_value = PROT_TM_xmlclean( value );
  if ( clean_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_value );
    free ( clean_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  PROT_TM_strcat( buffer, &buffer_len, "<oal-value>" );
  clean_oal_value = PROT_TM_xmlclean( oal_value );
  if ( clean_oal_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
    free ( clean_oal_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, oal_value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Generate_External_Entity_Event_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long ee_id, unsigned long eeevt_id, unsigned long evt_inst_id, int num_params, unsigned long eeedi_id[], const char *value[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Generate External Entity Event\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " ee-id=\"" );
  sprintf( int_buffer, "%lu", ee_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " eeevt-id=\"" );
  sprintf( int_buffer, "%lu", eeevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " eeedi-id=\"" );
    sprintf( int_buffer, "%lu", eeedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " eeedi-id=\"" );
    sprintf( int_buffer, "%lu", eeedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Create_External_Entity_Event_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long ee_id, unsigned long eeevt_id, unsigned long evt_inst_id, int num_params, unsigned long eeedi_id[], const char *value[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Create External Entity Event\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " ee-id=\"" );
  sprintf( int_buffer, "%lu", ee_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " eeevt-id=\"" );
  sprintf( int_buffer, "%lu", eeevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " eeedi-id=\"" );
    sprintf( int_buffer, "%lu", eeedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " eeedi-id=\"" );
    sprintf( int_buffer, "%lu", eeedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Create_Delayed_Event_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sm_id, unsigned long smevt_id, unsigned long evt_inst_id, int delay, int recurring )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Create Delayed Event\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " delay=\"" );
  sprintf( int_buffer, "%u", delay );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " recurring=\"" );
  sprintf( int_buffer, "%d", recurring );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Change_Expiry_of_Delayed_Event_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sm_id, unsigned long smevt_id, unsigned long evt_inst_id, int add, int delay )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Change Expiry of Delayed Event\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " add=\"" );
  sprintf( int_buffer, "%d", add );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " delay=\"" );
  sprintf( int_buffer, "%u", delay );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Delete_Delayed_Event_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long sm_id, unsigned long smevt_id, unsigned long evt_inst_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Delete Delayed Event\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Delayed_Event_Ready_encode( char **buffer, unsigned long dom_id, unsigned long sm_id, unsigned long smevt_id, unsigned long evt_inst_id, unsigned long recurring_evt_inst_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Delayed Event Ready\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " recurring-evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", recurring_evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Bridge_Operation_Invocation_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long ee_id, unsigned long brg_id, int num_params, unsigned long bparm_id[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Bridge Operation Invocation\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " ee-id=\"" );
  sprintf( int_buffer, "%lu", ee_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " brg-id=\"" );
  sprintf( int_buffer, "%lu", brg_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " bparm-id=\"" );
    sprintf( int_buffer, "%lu", bparm_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Bridge_Operation_Entry_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long ee_id, unsigned long brg_id, int num_params, unsigned long bparm_id[], const char *value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Bridge Operation Entry\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " ee-id=\"" );
  sprintf( int_buffer, "%lu", ee_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " brg-id=\"" );
  sprintf( int_buffer, "%lu", brg_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " bparm-id=\"" );
    sprintf( int_buffer, "%lu", bparm_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Bridge_Operation_Exit_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long ee_id, unsigned long brg_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Bridge Operation Exit\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " ee-id=\"" );
  sprintf( int_buffer, "%lu", ee_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " brg-id=\"" );
  sprintf( int_buffer, "%lu", brg_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Modify_Bridge_Operation_Parameter_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long ee_id, unsigned long brg_id, unsigned long bparm_id, const char *value, const char *oal_value )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Modify Bridge Operation Parameter\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " ee-id=\"" );
  sprintf( int_buffer, "%lu", ee_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " brg-id=\"" );
  sprintf( int_buffer, "%lu", brg_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " bparm-id=\"" );
  sprintf( int_buffer, "%lu", bparm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<value>" );
  clean_value = PROT_TM_xmlclean( value );
  if ( clean_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_value );
    free ( clean_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  PROT_TM_strcat( buffer, &buffer_len, "<oal-value>" );
  clean_oal_value = PROT_TM_xmlclean( oal_value );
  if ( clean_oal_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
    free ( clean_oal_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, oal_value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Relationship_Creation_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long rel_id, unsigned long from_obj_inst_id, const char *from_obj_inst_variable, unsigned long to_obj_inst_id, const char *to_obj_inst_variable, const char *txt_phrs )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_from_obj_inst_variable;
  char *clean_to_obj_inst_variable;
  char *clean_txt_phrs;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Relationship Creation\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " rel-id=\"" );
  sprintf( int_buffer, "%lu", rel_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " from-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", from_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " to-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", to_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<from-obj-inst-variable>" );
  clean_from_obj_inst_variable = PROT_TM_xmlclean( from_obj_inst_variable );
  if ( clean_from_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_from_obj_inst_variable );
    free ( clean_from_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, from_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</from-obj-inst-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<to-obj-inst-variable>" );
  clean_to_obj_inst_variable = PROT_TM_xmlclean( to_obj_inst_variable );
  if ( clean_to_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_to_obj_inst_variable );
    free ( clean_to_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, to_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</to-obj-inst-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<txt-phrs>" );
  clean_txt_phrs = PROT_TM_xmlclean( txt_phrs );
  if ( clean_txt_phrs )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_txt_phrs );
    free ( clean_txt_phrs );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, txt_phrs );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</txt-phrs>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Associative_Relationship_Creation_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long rel_id, unsigned long from_obj_inst_id, const char *from_obj_inst_variable, unsigned long to_obj_inst_id, const char *to_obj_inst_variable, unsigned long assoc_obj_inst_id, const char *assoc_obj_inst_variable, const char *txt_phrs )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_from_obj_inst_variable;
  char *clean_to_obj_inst_variable;
  char *clean_assoc_obj_inst_variable;
  char *clean_txt_phrs;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Associative Relationship Creation\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " rel-id=\"" );
  sprintf( int_buffer, "%lu", rel_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " from-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", from_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " to-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", to_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " assoc-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", assoc_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<from-obj-inst-variable>" );
  clean_from_obj_inst_variable = PROT_TM_xmlclean( from_obj_inst_variable );
  if ( clean_from_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_from_obj_inst_variable );
    free ( clean_from_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, from_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</from-obj-inst-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<to-obj-inst-variable>" );
  clean_to_obj_inst_variable = PROT_TM_xmlclean( to_obj_inst_variable );
  if ( clean_to_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_to_obj_inst_variable );
    free ( clean_to_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, to_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</to-obj-inst-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<assoc-obj-inst-variable>" );
  clean_assoc_obj_inst_variable = PROT_TM_xmlclean( assoc_obj_inst_variable );
  if ( clean_assoc_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_assoc_obj_inst_variable );
    free ( clean_assoc_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, assoc_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</assoc-obj-inst-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<txt-phrs>" );
  clean_txt_phrs = PROT_TM_xmlclean( txt_phrs );
  if ( clean_txt_phrs )
  {
   PROT_TM_strcat( buffer, &buffer_len, clean_txt_phrs );
    free ( clean_txt_phrs );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, txt_phrs );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</txt-phrs>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Relationship_Deletion_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long rel_id, unsigned long from_obj_inst_id, const char *from_obj_inst_variable, unsigned long to_obj_inst_id, const char *to_obj_inst_variable )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_from_obj_inst_variable;
  char *clean_to_obj_inst_variable;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Relationship Deletion\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " rel-id=\"" );
  sprintf( int_buffer, "%lu", rel_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " from-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", from_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " to-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", to_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<from-obj-inst-variable>" );
  clean_from_obj_inst_variable = PROT_TM_xmlclean( from_obj_inst_variable );
  if ( clean_from_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_from_obj_inst_variable );
    free ( clean_from_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, from_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</from-obj-inst-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<to-obj-inst-variable>" );
  clean_to_obj_inst_variable = PROT_TM_xmlclean( to_obj_inst_variable );
  if ( clean_to_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_to_obj_inst_variable );
    free ( clean_to_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, to_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</to-obj-inst-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Associative_Relationship_Deletion_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long rel_id, unsigned long from_obj_inst_id, const char *from_obj_inst_variable, unsigned long to_obj_inst_id, const char *to_obj_inst_variable, unsigned long assoc_obj_inst_id, const char *assoc_obj_inst_variable )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_from_obj_inst_variable;
  char *clean_to_obj_inst_variable;
  char *clean_assoc_obj_inst_variable;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Associative Relationship Deletion\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " rel-id=\"" );
  sprintf( int_buffer, "%lu", rel_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " from-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", from_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " to-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", to_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " assoc-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", assoc_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<from-obj-inst-variable>" );
  clean_from_obj_inst_variable = PROT_TM_xmlclean( from_obj_inst_variable );
  if ( clean_from_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_from_obj_inst_variable );
    free ( clean_from_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, from_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</from-obj-inst-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<to-obj-inst-variable>" );
  clean_to_obj_inst_variable = PROT_TM_xmlclean( to_obj_inst_variable );
  if ( clean_to_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_to_obj_inst_variable );
    free ( clean_to_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, to_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</to-obj-inst-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<assoc-obj-inst-variable>" );
  clean_assoc_obj_inst_variable = PROT_TM_xmlclean( assoc_obj_inst_variable );
  if ( clean_assoc_obj_inst_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_assoc_obj_inst_variable );
    free ( clean_assoc_obj_inst_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, assoc_obj_inst_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</assoc-obj-inst-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Class_Operation_Invocation_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long tfr_id, int num_params, unsigned long tparm_id[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Class Operation Invocation\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " tfr-id=\"" );
  sprintf( int_buffer, "%lu", tfr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " tparm-id=\"" );
    sprintf( int_buffer, "%lu", tparm_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Class_Operation_Entry_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long tfr_id, int num_params, unsigned long tparm_id[], const char *value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Class Operation Entry\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " tfr-id=\"" );
  sprintf( int_buffer, "%lu", tfr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " tparm-id=\"" );
    sprintf( int_buffer, "%lu", tparm_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Instance_Operation_Invocation_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long tfr_id, unsigned long obj_inst_id, const char *local_variable, int num_params, unsigned long tparm_id[], const char *oal_value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_local_variable;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Instance Operation Invocation\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " tfr-id=\"" );
  sprintf( int_buffer, "%lu", tfr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<oal-value" );
    PROT_TM_strcat( buffer, &buffer_len, " tparm-id=\"" );
    sprintf( int_buffer, "%lu", tparm_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_oal_value = PROT_TM_xmlclean( oal_value[loop] );
    if ( clean_oal_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
      free ( clean_oal_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, oal_value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Instance_Operation_Entry_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long tfr_id, unsigned long obj_inst_id, int num_params, unsigned long tparm_id[], const char *value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Instance Operation Entry\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " tfr-id=\"" );
  sprintf( int_buffer, "%lu", tfr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " tparm-id=\"" );
    sprintf( int_buffer, "%lu", tparm_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_Operation_Exit_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long tfr_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Operation Exit\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " tfr-id=\"" );
  sprintf( int_buffer, "%lu", tfr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Modify_Operation_Parameter_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long tfr_id, unsigned long tparm_id, const char *value, const char *oal_value )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Modify Operation Parameter\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " tfr-id=\"" );
  sprintf( int_buffer, "%lu", tfr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " tparm-id=\"" );
  sprintf( int_buffer, "%lu", tparm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<value>" );
  clean_value = PROT_TM_xmlclean( value );
  if ( clean_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_value );
    free ( clean_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  PROT_TM_strcat( buffer, &buffer_len, "<oal-value>" );
  clean_oal_value = PROT_TM_xmlclean( oal_value );
  if ( clean_oal_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
    free ( clean_oal_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, oal_value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_State_Entry_encode( char **buffer, int context, unsigned long dom_id, unsigned long sm_id, unsigned long smstt_id, unsigned long prev_smstt_id, unsigned long smevt_id, unsigned long evt_inst_id, unsigned long obj_inst_id, unsigned long orig_obj_inst_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify State Entry\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smstt-id=\"" );
  sprintf( int_buffer, "%lu", smstt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " prev-smstt-id=\"" );
  sprintf( int_buffer, "%lu", prev_smstt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " orig-obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", orig_obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Activity_Pending_encode(char **buffer, int context, char * type)
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Activity Pending\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " type=\"" );
  sprintf( int_buffer, "%s", type );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_State_Exit_encode( char **buffer, int context, unsigned long dom_id, unsigned long sm_id, unsigned long smstt_id, unsigned long obj_inst_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify State Exit\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smstt-id=\"" );
  sprintf( int_buffer, "%lu", smstt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_FBO_Entry_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long sm_id, unsigned long smstt_id, int num_params, unsigned long smedi_id[], const char *value[] )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  int loop;
  char *clean_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify FBO Entry\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smstt-id=\"" );
  sprintf( int_buffer, "%lu", smstt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " num-params=\"" );
  sprintf( int_buffer, "%d", num_params );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  for ( loop = 0; loop < num_params; ++loop )
  {
    PROT_TM_strcat( buffer, &buffer_len, "<value" );
    PROT_TM_strcat( buffer, &buffer_len, " smedi-id=\"" );
    sprintf( int_buffer, "%lu", smedi_id[loop] );
    PROT_TM_strcat( buffer, &buffer_len, int_buffer );
    PROT_TM_strcat( buffer, &buffer_len, "\" >" );
    clean_value = PROT_TM_xmlclean( value[loop] );
    if ( clean_value )
    {
      PROT_TM_strcat( buffer, &buffer_len, clean_value );
      free ( clean_value );
    }
    else
    {
      PROT_TM_strcat( buffer, &buffer_len, value[loop] );
    }
    PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_FBO_Exit_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long sm_id, unsigned long smstt_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify FBO Exit\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smstt-id=\"" );
  sprintf( int_buffer, "%lu", smstt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_Modify_Local_Variable_encode( char **buffer, int context, int stmt_id, int is_implicit, const char *local_variable, const char *value, const char *oal_value )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_local_variable;
  char *clean_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify Modify Local Variable\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " is-implicit=\"" );
  sprintf( int_buffer, "%d", is_implicit );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "<value>" );
  clean_value = PROT_TM_xmlclean( value );
  if ( clean_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_value );
    free ( clean_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</value>" );
  PROT_TM_strcat( buffer, &buffer_len, "<oal-value>" );
  clean_oal_value = PROT_TM_xmlclean( oal_value );
  if ( clean_oal_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
    free ( clean_oal_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, oal_value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Select_from_execution_encode( char **buffer, int context, int stmt_id, const char *cardinality, const char *key_lett, int is_implicit, const char *local_variable )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_cardinality;
  char *clean_key_lett;
  char *clean_local_variable;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Select from execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " is-implicit=\"" );
  sprintf( int_buffer, "%d", is_implicit );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<cardinality>" );
  clean_cardinality = PROT_TM_xmlclean( cardinality );
  if ( clean_cardinality )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_cardinality );
    free ( clean_cardinality );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, cardinality );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</cardinality>" );
  PROT_TM_strcat( buffer, &buffer_len, "<key-lett>" );
  clean_key_lett = PROT_TM_xmlclean( key_lett );
  if ( clean_key_lett )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_key_lett );
    free ( clean_key_lett );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, key_lett );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</key-lett>" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Select_related_by_execution_encode( char **buffer, int context, int stmt_id, const char *cardinality, unsigned long obj_inst_id, const char *chain, int is_implicit, const char *local_variable )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_cardinality;
  char *clean_chain;
  char *clean_local_variable;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Select related by execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " is-implicit=\"" );
  sprintf( int_buffer, "%d", is_implicit );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<cardinality>" );
  clean_cardinality = PROT_TM_xmlclean( cardinality );
  if ( clean_cardinality )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_cardinality );
    free ( clean_cardinality );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, cardinality );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</cardinality>" );
  PROT_TM_strcat( buffer, &buffer_len, "<chain>" );
  clean_chain = PROT_TM_xmlclean( chain );
  if ( clean_chain )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_chain );
    free ( clean_chain );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, chain );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</chain>" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Select_from_where_execution_encode( char **buffer, int context, int stmt_id, const char *cardinality, const char *key_lett, const char *where_clause, int is_implicit, const char *local_variable )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_cardinality;
  char *clean_key_lett;
  char *clean_where_clause;
  char *clean_local_variable;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Select from where execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " is-implicit=\"" );
  sprintf( int_buffer, "%d", is_implicit );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<cardinality>" );
  clean_cardinality = PROT_TM_xmlclean( cardinality );
  if ( clean_cardinality )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_cardinality );
    free ( clean_cardinality );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, cardinality );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</cardinality>" );
  PROT_TM_strcat( buffer, &buffer_len, "<key-lett>" );
  clean_key_lett = PROT_TM_xmlclean( key_lett );
  if ( clean_key_lett )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_key_lett );
    free ( clean_key_lett );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, key_lett );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</key-lett>" );
  PROT_TM_strcat( buffer, &buffer_len, "<where-clause>" );
  clean_where_clause = PROT_TM_xmlclean( where_clause );
  if ( clean_where_clause )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_where_clause );
    free ( clean_where_clause );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, where_clause );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</where-clause>" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Select_related_by_where_execution_encode( char **buffer, int context, int stmt_id, const char *cardinality, unsigned long obj_inst_id, const char *chain, const char *where_clause, int is_implicit, const char *local_variable )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_cardinality;
  char *clean_chain;
  char *clean_where_clause;
  char *clean_local_variable;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Select related by where execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " is-implicit=\"" );
  sprintf( int_buffer, "%d", is_implicit );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<cardinality>" );
  clean_cardinality = PROT_TM_xmlclean( cardinality );
  if ( clean_cardinality )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_cardinality );
    free ( clean_cardinality );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, cardinality );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</cardinality>" );
  PROT_TM_strcat( buffer, &buffer_len, "<chain>" );
  clean_chain = PROT_TM_xmlclean( chain );
  if ( clean_chain )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_chain );
    free ( clean_chain );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, chain );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</chain>" );
  PROT_TM_strcat( buffer, &buffer_len, "<where-clause>" );
  clean_where_clause = PROT_TM_xmlclean( where_clause );
  if ( clean_where_clause )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_where_clause );
    free ( clean_where_clause );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, where_clause );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</where-clause>" );
  PROT_TM_strcat( buffer, &buffer_len, "<local-variable>" );
  clean_local_variable = PROT_TM_xmlclean( local_variable );
  if ( clean_local_variable )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_local_variable );
    free ( clean_local_variable );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, local_variable );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</local-variable>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_If_execution_encode( char **buffer, int context, int stmt_id, const char *condition, int eval )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_condition;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log If execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " eval=\"" );
  sprintf( int_buffer, "%d", eval );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<condition>" );
  clean_condition = PROT_TM_xmlclean( condition );
  if ( clean_condition )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_condition );
    free ( clean_condition );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, condition );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</condition>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Elif_execution_encode( char **buffer, int context, int stmt_id, const char *condition, int eval )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_condition;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Elif execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " eval=\"" );
  sprintf( int_buffer, "%d", eval );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<condition>" );
  clean_condition = PROT_TM_xmlclean( condition );
  if ( clean_condition )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_condition );
    free ( clean_condition );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, condition );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</condition>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Else_execution_encode( char **buffer, int context, int stmt_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Else execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Log_Endif_execution_encode( char **buffer, int context, int stmt_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Endif execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Log_While_execution_encode( char **buffer, int context, int stmt_id, const char *condition, int eval )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_condition;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log While execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " eval=\"" );
  sprintf( int_buffer, "%d", eval );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<condition>" );
  clean_condition = PROT_TM_xmlclean( condition );
  if ( clean_condition )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_condition );
    free ( clean_condition );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, condition );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</condition>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Endwhile_execution_encode( char **buffer, int context, int stmt_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Endwhile execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Log_For_execution_encode( char **buffer, int context, int stmt_id, const char *loop_variable_name, const char *set_variable_name, int is_implicit, int eval )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_loop_variable_name;
  char *clean_set_variable_name;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log For execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " is-implicit=\"" );
  sprintf( int_buffer, "%d", is_implicit );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " eval=\"" );
  sprintf( int_buffer, "%d", eval );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<loop-variable-name>" );
  clean_loop_variable_name = PROT_TM_xmlclean( loop_variable_name );
  if ( clean_loop_variable_name )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_loop_variable_name );
    free ( clean_loop_variable_name );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, loop_variable_name );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</loop-variable-name>" );
  PROT_TM_strcat( buffer, &buffer_len, "<set-variable-name>" );
  clean_set_variable_name = PROT_TM_xmlclean( set_variable_name );
  if ( clean_set_variable_name )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_set_variable_name );
    free ( clean_set_variable_name );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, set_variable_name );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</set-variable-name>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Endfor_execution_encode( char **buffer, int context, int stmt_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Endfor execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Log_Break_execution_encode( char **buffer, int context, int stmt_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Break execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Log_Continue_execution_encode( char **buffer, int context, int stmt_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Continue execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Log_Return_execution_encode( char **buffer, int context, int stmt_id, const char *return_value, const char *oal_value )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_return_value;
  char *clean_oal_value;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Return execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<return-value>" );
  clean_return_value = PROT_TM_xmlclean( return_value );
  if ( clean_return_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_return_value );
    free ( clean_return_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, return_value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</return-value>" );
  PROT_TM_strcat( buffer, &buffer_len, "<oal-value>" );
  clean_oal_value = PROT_TM_xmlclean( oal_value );
  if ( clean_oal_value )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_oal_value );
    free ( clean_oal_value );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, oal_value );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</oal-value>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Control_execution_encode( char **buffer, int context, int stmt_id, const char *command )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];
  char *clean_command;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Control execution\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<command>" );
  clean_command = PROT_TM_xmlclean( command );
  if ( clean_command )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_command );
    free ( clean_command );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, command );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</command>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Log_Event_Ignored_encode( char **buffer, int context, unsigned long dom_id, unsigned long sm_id, unsigned long smstt_id, unsigned long obj_inst_id, unsigned long smevt_id, unsigned long evt_inst_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Event Ignored\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smstt-id=\"" );
  sprintf( int_buffer, "%lu", smstt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Log_Event_Cant_Happen_encode( char **buffer, int context, unsigned long dom_id, unsigned long sm_id, unsigned long smstt_id, unsigned long obj_inst_id, unsigned long smevt_id, unsigned long evt_inst_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Event Cant Happen\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " sm-id=\"" );
  sprintf( int_buffer, "%lu", sm_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smstt-id=\"" );
  sprintf( int_buffer, "%lu", smstt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-inst-id=\"" );
  sprintf( int_buffer, "%lu", obj_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " smevt-id=\"" );
  sprintf( int_buffer, "%lu", smevt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " evt-inst-id=\"" );
  sprintf( int_buffer, "%lu", evt_inst_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Log_Occurrence_encode( char **buffer, const char *severity, const char *message )
{
  struct tm *newtime;
  time_t long_time;
  char *clean_severity;
  char *clean_message;

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Log Occurrence\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " >" );
  PROT_TM_strcat( buffer, &buffer_len, "<severity>" );
  clean_severity = PROT_TM_xmlclean( severity );
  if ( clean_severity )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_severity );
    free ( clean_severity );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, severity );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</severity>" );
  PROT_TM_strcat( buffer, &buffer_len, "<message>" );
  clean_message = PROT_TM_xmlclean( message );
  if ( clean_message )
  {
    PROT_TM_strcat( buffer, &buffer_len, clean_message );
    free ( clean_message );
  }
  else
  {
    PROT_TM_strcat( buffer, &buffer_len, message );
  }
  PROT_TM_strcat( buffer, &buffer_len, "</message>" );
  PROT_TM_strcat( buffer, &buffer_len, "</debug>" );
}

void PROT_TM_Notify_MDA_Invocation_Begin_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long attr_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify MDA Invocation Begin\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " attr-id=\"" );
  sprintf( int_buffer, "%lu", attr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}

void PROT_TM_Notify_MDA_Invocation_End_encode( char **buffer, int context, int stmt_id, unsigned long dom_id, unsigned long obj_id, unsigned long attr_id )
{
  struct tm *newtime;
  time_t long_time;
  char int_buffer[64];

  size_t buffer_len = 512;
  *buffer = (char *) malloc( buffer_len );
  **buffer = '\0';

  PROT_TM_strcat( buffer, &buffer_len, "<debug cmd=\"Notify MDA Invocation End\" ts=\"" );
  time( &long_time );                /* Get time as long integer. */
  newtime = localtime( &long_time ); /* Convert to local time. */
  PROT_TM_strcat( buffer, &buffer_len, asctime( newtime ) );
  (*buffer) [strlen(*buffer)-1] = '\0';  /* remove \n from string returned by asctime */
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " context=\"" );
  sprintf( int_buffer, "%d", context );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " stmt-id=\"" );
  sprintf( int_buffer, "%d", stmt_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " dom-id=\"" );
  sprintf( int_buffer, "%lu", dom_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " obj-id=\"" );
  sprintf( int_buffer, "%lu", obj_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " attr-id=\"" );
  sprintf( int_buffer, "%lu", attr_id );
  PROT_TM_strcat( buffer, &buffer_len, int_buffer );
  PROT_TM_strcat( buffer, &buffer_len, "\"" );
  PROT_TM_strcat( buffer, &buffer_len, " />" );
}
#endif


